"""Dataclasses for all structs in the HyperdriveRegistryTest contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain """

# super() call methods are generic, while our version adds values & types
# pylint: disable=arguments-differ

# contracts have PascalCase names
# pylint: disable=invalid-name
# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments
# unable to determine which imports will be used in the generated code
# pylint: disable=unused-import
# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return
from __future__ import annotations

from dataclasses import dataclass

from web3.types import ABIEvent, ABIEventParams

AddLiquidity = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=False, name="lpAmount", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="lpSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="AddLiquidity",
    type="event",
)

Approval = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="owner", type="address"),
        ABIEventParams(indexed=True, name="spender", type="address"),
        ABIEventParams(indexed=False, name="value", type="uint256"),
    ],
    name="Approval",
    type="event",
)

ApprovalForAll = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="account", type="address"),
        ABIEventParams(indexed=True, name="operator", type="address"),
        ABIEventParams(indexed=False, name="approved", type="bool"),
    ],
    name="ApprovalForAll",
    type="event",
)

CloseLong = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="CloseLong",
    type="event",
)

CloseShort = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="basePayment", type="uint256"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="CloseShort",
    type="event",
)

CollectGovernanceFee = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="collector", type="address"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
    ],
    name="CollectGovernanceFee",
    type="event",
)

CreateCheckpoint = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="checkpointTime", type="uint256"),
        ABIEventParams(
            indexed=False, name="checkpointVaultSharePrice", type="uint256"
        ),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="maturedShorts", type="uint256"),
        ABIEventParams(indexed=False, name="maturedLongs", type="uint256"),
        ABIEventParams(indexed=False, name="lpSharePrice", type="uint256"),
    ],
    name="CreateCheckpoint",
    type="event",
)

Deployed = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(
            indexed=True, name="deployerCoordinator", type="address"
        ),
        ABIEventParams(indexed=False, name="hyperdrive", type="address"),
        ABIEventParams(indexed=False, name="name", type="string"),
        ABIEventParams(indexed=False, name="config", type="tuple"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="Deployed",
    type="event",
)

FactoryInfoUpdated = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="factory", type="address"),
        ABIEventParams(indexed=True, name="data", type="uint256"),
    ],
    name="FactoryInfoUpdated",
    type="event",
)

Initialize = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=False, name="lpAmount", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="apr", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="Initialize",
    type="event",
)

InstanceInfoUpdated = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="hyperdrive", type="address"),
        ABIEventParams(indexed=True, name="data", type="uint256"),
        ABIEventParams(indexed=True, name="factory", type="address"),
    ],
    name="InstanceInfoUpdated",
    type="event",
)

OpenLong = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="OpenLong",
    type="event",
)

OpenShort = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="trader", type="address"),
        ABIEventParams(indexed=True, name="assetId", type="uint256"),
        ABIEventParams(indexed=False, name="maturityTime", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="baseProceeds", type="uint256"),
        ABIEventParams(indexed=False, name="bondAmount", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="OpenShort",
    type="event",
)

PauseStatusUpdated = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="isPaused", type="bool"),
    ],
    name="PauseStatusUpdated",
    type="event",
)

RedeemWithdrawalShares = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(
            indexed=False, name="withdrawalShareAmount", type="uint256"
        ),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="RedeemWithdrawalShares",
    type="event",
)

RemoveLiquidity = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="provider", type="address"),
        ABIEventParams(indexed=True, name="destination", type="address"),
        ABIEventParams(indexed=False, name="lpAmount", type="uint256"),
        ABIEventParams(indexed=False, name="amount", type="uint256"),
        ABIEventParams(indexed=False, name="vaultSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="asBase", type="bool"),
        ABIEventParams(
            indexed=False, name="withdrawalShareAmount", type="uint256"
        ),
        ABIEventParams(indexed=False, name="lpSharePrice", type="uint256"),
        ABIEventParams(indexed=False, name="extraData", type="bytes"),
    ],
    name="RemoveLiquidity",
    type="event",
)

Sweep = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="collector", type="address"),
        ABIEventParams(indexed=True, name="target", type="address"),
    ],
    name="Sweep",
    type="event",
)

TransferSingle = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=True, name="operator", type="address"),
        ABIEventParams(indexed=True, name="from", type="address"),
        ABIEventParams(indexed=True, name="to", type="address"),
        ABIEventParams(indexed=False, name="id", type="uint256"),
        ABIEventParams(indexed=False, name="value", type="uint256"),
    ],
    name="TransferSingle",
    type="event",
)

log = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="", type="string"),
    ],
    name="log",
    type="event",
)

log_address = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="", type="address"),
    ],
    name="log_address",
    type="event",
)

log_array = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="val", type="address[]"),
    ],
    name="log_array",
    type="event",
)

log_bytes = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="", type="bytes"),
    ],
    name="log_bytes",
    type="event",
)

log_bytes32 = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="", type="bytes32"),
    ],
    name="log_bytes32",
    type="event",
)

log_int = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="", type="int256"),
    ],
    name="log_int",
    type="event",
)

log_named_address = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="key", type="string"),
        ABIEventParams(indexed=False, name="val", type="address"),
    ],
    name="log_named_address",
    type="event",
)

log_named_array = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="key", type="string"),
        ABIEventParams(indexed=False, name="val", type="address[]"),
    ],
    name="log_named_array",
    type="event",
)

log_named_bytes = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="key", type="string"),
        ABIEventParams(indexed=False, name="val", type="bytes"),
    ],
    name="log_named_bytes",
    type="event",
)

log_named_bytes32 = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="key", type="string"),
        ABIEventParams(indexed=False, name="val", type="bytes32"),
    ],
    name="log_named_bytes32",
    type="event",
)

log_named_decimal_int = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="key", type="string"),
        ABIEventParams(indexed=False, name="val", type="int256"),
        ABIEventParams(indexed=False, name="decimals", type="uint256"),
    ],
    name="log_named_decimal_int",
    type="event",
)

log_named_decimal_uint = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="key", type="string"),
        ABIEventParams(indexed=False, name="val", type="uint256"),
        ABIEventParams(indexed=False, name="decimals", type="uint256"),
    ],
    name="log_named_decimal_uint",
    type="event",
)

log_named_int = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="key", type="string"),
        ABIEventParams(indexed=False, name="val", type="int256"),
    ],
    name="log_named_int",
    type="event",
)

log_named_string = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="key", type="string"),
        ABIEventParams(indexed=False, name="val", type="string"),
    ],
    name="log_named_string",
    type="event",
)

log_named_uint = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="key", type="string"),
        ABIEventParams(indexed=False, name="val", type="uint256"),
    ],
    name="log_named_uint",
    type="event",
)

log_string = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="", type="string"),
    ],
    name="log_string",
    type="event",
)

log_uint = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="", type="uint256"),
    ],
    name="log_uint",
    type="event",
)

logs = ABIEvent(
    anonymous=False,
    inputs=[
        ABIEventParams(indexed=False, name="", type="bytes"),
    ],
    name="logs",
    type="event",
)


@dataclass
class ErrorInfo:
    """Custom contract error information."""

    name: str
    selector: str
    signature: str
    inputs: list[ErrorParams]


@dataclass
class ErrorParams:
    """Parameter info for custom contract errors."""

    name: str
    solidity_type: str
    python_type: str


LnInvalidInputError = ErrorInfo(
    inputs=[],
    name="LnInvalidInput",
    selector="0xe61b4975",
    signature="LnInvalidInput()",
)

UnsafeCastToInt256Error = ErrorInfo(
    inputs=[],
    name="UnsafeCastToInt256",
    selector="0x72dd4e02",
    signature="UnsafeCastToInt256()",
)

WhaleBalanceExceededError = ErrorInfo(
    inputs=[],
    name="WhaleBalanceExceeded",
    selector="0xc4649d28",
    signature="WhaleBalanceExceeded()",
)

WhaleIsContractError = ErrorInfo(
    inputs=[],
    name="WhaleIsContract",
    selector="0x98d85a67",
    signature="WhaleIsContract()",
)
