"""A web3.py Contract class for the HyperdriveStorage contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain"""

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overriden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long


from __future__ import annotations

from typing import Any, Type, cast

from eth_abi.codec import ABICodec
from eth_abi.registry import registry as default_registry
from eth_account.signers.local import LocalAccount
from eth_typing import ChecksumAddress, HexStr
from hexbytes import HexBytes
from typing_extensions import Self
from web3 import Web3
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractFunctions,
)
from web3.exceptions import FallbackNotFound
from web3.types import ABI, ABIFunction

from .utilities import get_abi_input_types, try_bytecode_hexbytes

structs = {}


class HyperdriveStorageContractFunctions(ContractFunctions):
    """ContractFunctions for the HyperdriveStorage contract."""

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)


class HyperdriveStorageReentrancyGuardReentrantCallContractError:
    """ContractError for ReentrancyGuardReentrantCall."""

    # @combomethod destroys return types, so we are redefining functions as both class and instance
    # pylint: disable=function-redefined

    # 4 byte error selector
    selector: str
    # error signature, i.e. CustomError(uint256,bool)
    signature: str

    # pylint: disable=useless-parent-delegation
    def __init__(
        self: "HyperdriveStorageReentrancyGuardReentrantCallContractError",
    ) -> None:
        self.selector = "0x3ee5aeb5"
        self.signature = "ReentrancyGuardReentrantCall()"

    def decode_error_data(  # type: ignore
        self: "HyperdriveStorageReentrancyGuardReentrantCallContractError",
        data: HexBytes,
        # TODO: instead of returning a tuple, return a dataclass with the input names and types just like we do for functions
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in hyperdrivestorage_abi
                if item.get("name") == "ReentrancyGuardReentrantCall"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded

    @classmethod
    def decode_error_data(  # type: ignore
        cls: Type["HyperdriveStorageReentrancyGuardReentrantCallContractError"],
        data: HexBytes,
    ) -> tuple[Any, ...]:
        """Decodes error data returns from a smart contract."""
        error_abi = cast(
            ABIFunction,
            [
                item
                for item in hyperdrivestorage_abi
                if item.get("name") == "ReentrancyGuardReentrantCall"
                and item.get("type") == "error"
            ][0],
        )
        types = get_abi_input_types(error_abi)
        abi_codec = ABICodec(default_registry)
        decoded = abi_codec.decode(types, data)
        return decoded


class HyperdriveStorageContractErrors:
    """ContractErrors for the HyperdriveStorage contract."""

    ReentrancyGuardReentrantCall: (
        HyperdriveStorageReentrancyGuardReentrantCallContractError
    )

    def __init__(
        self,
    ) -> None:
        self.ReentrancyGuardReentrantCall = (
            HyperdriveStorageReentrancyGuardReentrantCallContractError()
        )

        self._all = [
            self.ReentrancyGuardReentrantCall,
        ]

    def decode_custom_error(self, data: str) -> tuple[Any, ...]:
        """Decodes a custom contract error."""
        selector = data[:10]
        for err in self._all:
            if err.selector == selector:
                return err.decode_error_data(HexBytes(data[10:]))

        raise ValueError(
            f"HyperdriveStorage does not have a selector matching {selector}"
        )


hyperdrivestorage_abi: ABI = cast(
    ABI,
    [{"type": "error", "name": "ReentrancyGuardReentrantCall", "inputs": []}],
)
# pylint: disable=line-too-long
hyperdrivestorage_bytecode = HexStr("0x")


class HyperdriveStorageContract(Contract):
    """A web3.py Contract class for the HyperdriveStorage contract."""

    abi: ABI = hyperdrivestorage_abi
    bytecode: bytes | None = try_bytecode_hexbytes(
        hyperdrivestorage_bytecode, "hyperdrivestorage"
    )

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        try:
            # Initialize parent Contract class
            super().__init__(address=address)
            self.functions = HyperdriveStorageContractFunctions(hyperdrivestorage_abi, self.w3, address)  # type: ignore

            self.errors = HyperdriveStorageContractErrors()

        except FallbackNotFound:
            print("Fallback function not found. Continuing...")

    errors: HyperdriveStorageContractErrors = HyperdriveStorageContractErrors()

    functions: HyperdriveStorageContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.rawTransaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = HyperdriveStorageContractFunctions(
            hyperdrivestorage_abi, w3, None
        )
        contract.errors = HyperdriveStorageContractErrors()

        return contract
