"""A web3.py Contract class for the IRenzoOracle contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain"""

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overriden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long


from __future__ import annotations

from typing import Any, Type, cast

from eth_account.signers.local import LocalAccount
from eth_typing import ChecksumAddress, HexStr
from typing_extensions import Self
from web3 import Web3
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractFunction,
    ContractFunctions,
)
from web3.exceptions import FallbackNotFound
from web3.types import ABI, BlockIdentifier, CallOverride, TxParams

from .utilities import (
    dataclass_to_tuple,
    rename_returned_types,
    try_bytecode_hexbytes,
)

structs = {}


class IRenzoOracleCalculateMintAmountContractFunction(ContractFunction):
    """ContractFunction for the calculateMintAmount method."""

    def __call__(self, currentValueInProtocol: int, newValueAdded: int, existingEzETHSupply: int) -> IRenzoOracleCalculateMintAmountContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(currentValueInProtocol),
            dataclass_to_tuple(newValueAdded),
            dataclass_to_tuple(existingEzETHSupply),
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRenzoOracleCalculateRedeemAmountContractFunction(ContractFunction):
    """ContractFunction for the calculateRedeemAmount method."""

    def __call__(self, ezETHBeingBurned: int, existingEzETHSupply: int, currentValueInProtocol: int) -> IRenzoOracleCalculateRedeemAmountContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(ezETHBeingBurned),
            dataclass_to_tuple(existingEzETHSupply),
            dataclass_to_tuple(currentValueInProtocol),
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRenzoOracleLookupTokenAmountFromValueContractFunction(ContractFunction):
    """ContractFunction for the lookupTokenAmountFromValue method."""

    def __call__(self, token: str, value: int) -> IRenzoOracleLookupTokenAmountFromValueContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(token), dataclass_to_tuple(value)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRenzoOracleLookupTokenValueContractFunction(ContractFunction):
    """ContractFunction for the lookupTokenValue method."""

    def __call__(self, token: str, balance: int) -> IRenzoOracleLookupTokenValueContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(token), dataclass_to_tuple(balance)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRenzoOracleLookupTokenValuesContractFunction(ContractFunction):
    """ContractFunction for the lookupTokenValues method."""

    def __call__(self, tokens: list[str], balances: list[int]) -> IRenzoOracleLookupTokenValuesContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(tokens), dataclass_to_tuple(balances)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class IRenzoOracleContractFunctions(ContractFunctions):
    """ContractFunctions for the IRenzoOracle contract."""

    calculateMintAmount: IRenzoOracleCalculateMintAmountContractFunction

    calculateRedeemAmount: IRenzoOracleCalculateRedeemAmountContractFunction

    lookupTokenAmountFromValue: (
        IRenzoOracleLookupTokenAmountFromValueContractFunction
    )

    lookupTokenValue: IRenzoOracleLookupTokenValueContractFunction

    lookupTokenValues: IRenzoOracleLookupTokenValuesContractFunction

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)
        self.calculateMintAmount = (
            IRenzoOracleCalculateMintAmountContractFunction.factory(
                "calculateMintAmount",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="calculateMintAmount",
            )
        )
        self.calculateRedeemAmount = (
            IRenzoOracleCalculateRedeemAmountContractFunction.factory(
                "calculateRedeemAmount",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="calculateRedeemAmount",
            )
        )
        self.lookupTokenAmountFromValue = (
            IRenzoOracleLookupTokenAmountFromValueContractFunction.factory(
                "lookupTokenAmountFromValue",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="lookupTokenAmountFromValue",
            )
        )
        self.lookupTokenValue = (
            IRenzoOracleLookupTokenValueContractFunction.factory(
                "lookupTokenValue",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="lookupTokenValue",
            )
        )
        self.lookupTokenValues = (
            IRenzoOracleLookupTokenValuesContractFunction.factory(
                "lookupTokenValues",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="lookupTokenValues",
            )
        )


irenzooracle_abi: ABI = cast(
    ABI,
    [
        {
            "type": "function",
            "name": "calculateMintAmount",
            "inputs": [
                {
                    "name": "_currentValueInProtocol",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "_newValueAdded",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "_existingEzETHSupply",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "calculateRedeemAmount",
            "inputs": [
                {
                    "name": "_ezETHBeingBurned",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "_existingEzETHSupply",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "_currentValueInProtocol",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "lookupTokenAmountFromValue",
            "inputs": [
                {
                    "name": "_token",
                    "type": "address",
                    "internalType": "contract IERC20",
                },
                {
                    "name": "_value",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "lookupTokenValue",
            "inputs": [
                {
                    "name": "_token",
                    "type": "address",
                    "internalType": "contract IERC20",
                },
                {
                    "name": "_balance",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "lookupTokenValues",
            "inputs": [
                {
                    "name": "_tokens",
                    "type": "address[]",
                    "internalType": "contract IERC20[]",
                },
                {
                    "name": "_balances",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
            ],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
    ],
)
# pylint: disable=line-too-long
irenzooracle_bytecode = HexStr("0x")


class IRenzoOracleContract(Contract):
    """A web3.py Contract class for the IRenzoOracle contract."""

    abi: ABI = irenzooracle_abi
    bytecode: bytes | None = try_bytecode_hexbytes(
        irenzooracle_bytecode, "irenzooracle"
    )

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        try:
            # Initialize parent Contract class
            super().__init__(address=address)
            self.functions = IRenzoOracleContractFunctions(irenzooracle_abi, self.w3, address)  # type: ignore

        except FallbackNotFound:
            print("Fallback function not found. Continuing...")

    functions: IRenzoOracleContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.rawTransaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = IRenzoOracleContractFunctions(
            irenzooracle_abi, w3, None
        )

        return contract
