"""A web3.py Contract class for the Vm contract.

DO NOT EDIT.  This file was generated by pypechain.  See documentation at
https://github.com/delvtech/pypechain"""

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overriden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long


from __future__ import annotations

from typing import Any, NamedTuple, Type, cast, overload

from eth_account.signers.local import LocalAccount
from eth_typing import ChecksumAddress, HexStr
from typing_extensions import Self
from web3 import Web3
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractFunction,
    ContractFunctions,
)
from web3.exceptions import FallbackNotFound
from web3.types import ABI, BlockIdentifier, CallOverride, TxParams

from .utilities import (
    dataclass_to_tuple,
    rename_returned_types,
    try_bytecode_hexbytes,
)
from .VmSafeTypes import (
    AccountAccess,
    ChainInfo,
    DirEntry,
    EthGetLogs,
    FfiResult,
    FsMetadata,
    Log,
    Rpc,
    StorageAccess,
    Wallet,
)

structs = {
    "Wallet": Wallet,
    "EthGetLogs": EthGetLogs,
    "FsMetadata": FsMetadata,
    "Log": Log,
    "DirEntry": DirEntry,
    "Rpc": Rpc,
    "ChainInfo": ChainInfo,
    "StorageAccess": StorageAccess,
    "AccountAccess": AccountAccess,
    "FfiResult": FfiResult,
}


class VmAccessesContractFunction(ContractFunction):
    """ContractFunction for the accesses method."""

    class ReturnValues(NamedTuple):
        """The return named tuple for Accesses."""

        readSlots: list[bytes]
        writeSlots: list[bytes]

    def __call__(self, target: str) -> VmAccessesContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(target))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> ReturnValues:
        """returns ReturnValues."""
        # Define the expected return types from the smart contract call

        return_types = [list[bytes], list[bytes]]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return self.ReturnValues(
            *rename_returned_types(structs, return_types, raw_values)
        )


class VmActiveForkContractFunction(ContractFunction):
    """ContractFunction for the activeFork method."""

    def __call__(self) -> VmActiveForkContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmAddrContractFunction(ContractFunction):
    """ContractFunction for the addr method."""

    def __call__(self, privateKey: int) -> VmAddrContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(privateKey))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmAllowCheatcodesContractFunction(ContractFunction):
    """ContractFunction for the allowCheatcodes method."""

    def __call__(self, account: str) -> VmAllowCheatcodesContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(account))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmAssertApproxEqAbsContractFunction0(ContractFunction):
    """ContractFunction for the assertApproxEqAbs method."""

    def __call__(self, left: int, right: int, maxDelta: int) -> VmAssertApproxEqAbsContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxDelta))  # type: ignore
        return cast(VmAssertApproxEqAbsContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqAbsContractFunction1(ContractFunction):
    """ContractFunction for the assertApproxEqAbs method."""

    def __call__(self, left: int, right: int, maxDelta: int) -> VmAssertApproxEqAbsContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxDelta))  # type: ignore
        return cast(VmAssertApproxEqAbsContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqAbsContractFunction2(ContractFunction):
    """ContractFunction for the assertApproxEqAbs method."""

    def __call__(self, left: int, right: int, maxDelta: int, error: str) -> VmAssertApproxEqAbsContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxDelta), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertApproxEqAbsContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqAbsContractFunction3(ContractFunction):
    """ContractFunction for the assertApproxEqAbs method."""

    def __call__(self, left: int, right: int, maxDelta: int, error: str) -> VmAssertApproxEqAbsContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxDelta), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertApproxEqAbsContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqAbsContractFunction(ContractFunction):
    """ContractFunction for the assertApproxEqAbs method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, maxDelta: int) -> VmAssertApproxEqAbsContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxDelta: int) -> VmAssertApproxEqAbsContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxDelta: int, error: str) -> VmAssertApproxEqAbsContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxDelta: int, error: str) -> VmAssertApproxEqAbsContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertApproxEqAbsContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertApproxEqAbsDecimalContractFunction0(ContractFunction):
    """ContractFunction for the assertApproxEqAbsDecimal method."""

    def __call__(self, left: int, right: int, maxDelta: int, decimals: int) -> VmAssertApproxEqAbsDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxDelta), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertApproxEqAbsDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqAbsDecimalContractFunction1(ContractFunction):
    """ContractFunction for the assertApproxEqAbsDecimal method."""

    def __call__(self, left: int, right: int, maxDelta: int, decimals: int) -> VmAssertApproxEqAbsDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxDelta), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertApproxEqAbsDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqAbsDecimalContractFunction2(ContractFunction):
    """ContractFunction for the assertApproxEqAbsDecimal method."""

    def __call__(self, left: int, right: int, maxDelta: int, decimals: int, error: str) -> VmAssertApproxEqAbsDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxDelta), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertApproxEqAbsDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqAbsDecimalContractFunction3(ContractFunction):
    """ContractFunction for the assertApproxEqAbsDecimal method."""

    def __call__(self, left: int, right: int, maxDelta: int, decimals: int, error: str) -> VmAssertApproxEqAbsDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxDelta), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertApproxEqAbsDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqAbsDecimalContractFunction(ContractFunction):
    """ContractFunction for the assertApproxEqAbsDecimal method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, maxDelta: int, decimals: int) -> VmAssertApproxEqAbsDecimalContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxDelta: int, decimals: int) -> VmAssertApproxEqAbsDecimalContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxDelta: int, decimals: int, error: str) -> VmAssertApproxEqAbsDecimalContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxDelta: int, decimals: int, error: str) -> VmAssertApproxEqAbsDecimalContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertApproxEqAbsDecimalContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertApproxEqRelContractFunction0(ContractFunction):
    """ContractFunction for the assertApproxEqRel method."""

    def __call__(self, left: int, right: int, maxPercentDelta: int, error: str) -> VmAssertApproxEqRelContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxPercentDelta), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertApproxEqRelContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqRelContractFunction1(ContractFunction):
    """ContractFunction for the assertApproxEqRel method."""

    def __call__(self, left: int, right: int, maxPercentDelta: int) -> VmAssertApproxEqRelContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxPercentDelta))  # type: ignore
        return cast(VmAssertApproxEqRelContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqRelContractFunction2(ContractFunction):
    """ContractFunction for the assertApproxEqRel method."""

    def __call__(self, left: int, right: int, maxPercentDelta: int, error: str) -> VmAssertApproxEqRelContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxPercentDelta), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertApproxEqRelContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqRelContractFunction3(ContractFunction):
    """ContractFunction for the assertApproxEqRel method."""

    def __call__(self, left: int, right: int, maxPercentDelta: int) -> VmAssertApproxEqRelContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxPercentDelta))  # type: ignore
        return cast(VmAssertApproxEqRelContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqRelContractFunction(ContractFunction):
    """ContractFunction for the assertApproxEqRel method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, maxPercentDelta: int, error: str) -> VmAssertApproxEqRelContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxPercentDelta: int) -> VmAssertApproxEqRelContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxPercentDelta: int, error: str) -> VmAssertApproxEqRelContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxPercentDelta: int) -> VmAssertApproxEqRelContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertApproxEqRelContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertApproxEqRelDecimalContractFunction0(ContractFunction):
    """ContractFunction for the assertApproxEqRelDecimal method."""

    def __call__(self, left: int, right: int, maxPercentDelta: int, decimals: int) -> VmAssertApproxEqRelDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxPercentDelta), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertApproxEqRelDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqRelDecimalContractFunction1(ContractFunction):
    """ContractFunction for the assertApproxEqRelDecimal method."""

    def __call__(self, left: int, right: int, maxPercentDelta: int, decimals: int, error: str) -> VmAssertApproxEqRelDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxPercentDelta), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertApproxEqRelDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqRelDecimalContractFunction2(ContractFunction):
    """ContractFunction for the assertApproxEqRelDecimal method."""

    def __call__(self, left: int, right: int, maxPercentDelta: int, decimals: int) -> VmAssertApproxEqRelDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxPercentDelta), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertApproxEqRelDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqRelDecimalContractFunction3(ContractFunction):
    """ContractFunction for the assertApproxEqRelDecimal method."""

    def __call__(self, left: int, right: int, maxPercentDelta: int, decimals: int, error: str) -> VmAssertApproxEqRelDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(maxPercentDelta), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertApproxEqRelDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertApproxEqRelDecimalContractFunction(ContractFunction):
    """ContractFunction for the assertApproxEqRelDecimal method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, maxPercentDelta: int, decimals: int) -> VmAssertApproxEqRelDecimalContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxPercentDelta: int, decimals: int, error: str) -> VmAssertApproxEqRelDecimalContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxPercentDelta: int, decimals: int) -> VmAssertApproxEqRelDecimalContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, maxPercentDelta: int, decimals: int, error: str) -> VmAssertApproxEqRelDecimalContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertApproxEqRelDecimalContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertEqContractFunction0(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[bytes], right: list[bytes]) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction1(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[int], right: list[int], error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction2(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: str, right: str, error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction3(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: str, right: str, error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction4(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[str], right: list[str]) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction5(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[str], right: list[str], error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction6(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: bool, right: bool, error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction7(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: str, right: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction8(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[int], right: list[int], error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction9(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[bool], right: list[bool]) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction10(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[int], right: list[int]) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction11(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction12(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: bytes, right: bytes) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction13(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction14(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[int], right: list[int]) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction15(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: bytes, right: bytes) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction16(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: int, right: int) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction17(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: bytes, right: bytes, error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction18(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[str], right: list[str]) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction19(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[bytes], right: list[bytes], error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction20(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: bytes, right: bytes, error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction21(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[bool], right: list[bool], error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction22(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[bytes], right: list[bytes]) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction23(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[str], right: list[str], error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction24(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: str, right: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction25(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: list[bytes], right: list[bytes], error: str) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction26(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: bool, right: bool) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction27(ContractFunction):
    """ContractFunction for the assertEq method."""

    def __call__(self, left: int, right: int) -> VmAssertEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqContractFunction(ContractFunction):
    """ContractFunction for the assertEq method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: list[bytes], right: list[bytes]) -> VmAssertEqContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[int], right: list[int], error: str) -> VmAssertEqContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: str, right: str, error: str) -> VmAssertEqContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: str, right: str, error: str) -> VmAssertEqContractFunction3:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[str], right: list[str]) -> VmAssertEqContractFunction4:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[str], right: list[str], error: str) -> VmAssertEqContractFunction5:  # type: ignore
        ...

    @overload
    def __call__(self, left: bool, right: bool, error: str) -> VmAssertEqContractFunction6:  # type: ignore
        ...

    @overload
    def __call__(self, left: str, right: str) -> VmAssertEqContractFunction7:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[int], right: list[int], error: str) -> VmAssertEqContractFunction8:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bool], right: list[bool]) -> VmAssertEqContractFunction9:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[int], right: list[int]) -> VmAssertEqContractFunction10:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertEqContractFunction11:  # type: ignore
        ...

    @overload
    def __call__(self, left: bytes, right: bytes) -> VmAssertEqContractFunction12:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertEqContractFunction13:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[int], right: list[int]) -> VmAssertEqContractFunction14:  # type: ignore
        ...

    @overload
    def __call__(self, left: bytes, right: bytes) -> VmAssertEqContractFunction15:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int) -> VmAssertEqContractFunction16:  # type: ignore
        ...

    @overload
    def __call__(self, left: bytes, right: bytes, error: str) -> VmAssertEqContractFunction17:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[str], right: list[str]) -> VmAssertEqContractFunction18:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bytes], right: list[bytes], error: str) -> VmAssertEqContractFunction19:  # type: ignore
        ...

    @overload
    def __call__(self, left: bytes, right: bytes, error: str) -> VmAssertEqContractFunction20:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bool], right: list[bool], error: str) -> VmAssertEqContractFunction21:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bytes], right: list[bytes]) -> VmAssertEqContractFunction22:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[str], right: list[str], error: str) -> VmAssertEqContractFunction23:  # type: ignore
        ...

    @overload
    def __call__(self, left: str, right: str) -> VmAssertEqContractFunction24:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bytes], right: list[bytes], error: str) -> VmAssertEqContractFunction25:  # type: ignore
        ...

    @overload
    def __call__(self, left: bool, right: bool) -> VmAssertEqContractFunction26:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int) -> VmAssertEqContractFunction27:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertEqContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertEqDecimalContractFunction0(ContractFunction):
    """ContractFunction for the assertEqDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertEqDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertEqDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqDecimalContractFunction1(ContractFunction):
    """ContractFunction for the assertEqDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertEqDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertEqDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqDecimalContractFunction2(ContractFunction):
    """ContractFunction for the assertEqDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertEqDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqDecimalContractFunction3(ContractFunction):
    """ContractFunction for the assertEqDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertEqDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertEqDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertEqDecimalContractFunction(ContractFunction):
    """ContractFunction for the assertEqDecimal method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertEqDecimalContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertEqDecimalContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertEqDecimalContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertEqDecimalContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertEqDecimalContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertFalseContractFunction0(ContractFunction):
    """ContractFunction for the assertFalse method."""

    def __call__(self, condition: bool, error: str) -> VmAssertFalseContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(condition), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertFalseContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertFalseContractFunction1(ContractFunction):
    """ContractFunction for the assertFalse method."""

    def __call__(self, condition: bool) -> VmAssertFalseContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmAssertFalseContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertFalseContractFunction(ContractFunction):
    """ContractFunction for the assertFalse method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, condition: bool, error: str) -> VmAssertFalseContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, condition: bool) -> VmAssertFalseContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertFalseContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertGeContractFunction0(ContractFunction):
    """ContractFunction for the assertGe method."""

    def __call__(self, left: int, right: int) -> VmAssertGeContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertGeContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGeContractFunction1(ContractFunction):
    """ContractFunction for the assertGe method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertGeContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertGeContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGeContractFunction2(ContractFunction):
    """ContractFunction for the assertGe method."""

    def __call__(self, left: int, right: int) -> VmAssertGeContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertGeContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGeContractFunction3(ContractFunction):
    """ContractFunction for the assertGe method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertGeContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertGeContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGeContractFunction(ContractFunction):
    """ContractFunction for the assertGe method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int) -> VmAssertGeContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertGeContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int) -> VmAssertGeContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertGeContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertGeContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertGeDecimalContractFunction0(ContractFunction):
    """ContractFunction for the assertGeDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertGeDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertGeDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGeDecimalContractFunction1(ContractFunction):
    """ContractFunction for the assertGeDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertGeDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertGeDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGeDecimalContractFunction2(ContractFunction):
    """ContractFunction for the assertGeDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertGeDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertGeDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGeDecimalContractFunction3(ContractFunction):
    """ContractFunction for the assertGeDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertGeDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertGeDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGeDecimalContractFunction(ContractFunction):
    """ContractFunction for the assertGeDecimal method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertGeDecimalContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertGeDecimalContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertGeDecimalContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertGeDecimalContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertGeDecimalContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertGtContractFunction0(ContractFunction):
    """ContractFunction for the assertGt method."""

    def __call__(self, left: int, right: int) -> VmAssertGtContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertGtContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGtContractFunction1(ContractFunction):
    """ContractFunction for the assertGt method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertGtContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertGtContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGtContractFunction2(ContractFunction):
    """ContractFunction for the assertGt method."""

    def __call__(self, left: int, right: int) -> VmAssertGtContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertGtContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGtContractFunction3(ContractFunction):
    """ContractFunction for the assertGt method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertGtContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertGtContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGtContractFunction(ContractFunction):
    """ContractFunction for the assertGt method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int) -> VmAssertGtContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertGtContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int) -> VmAssertGtContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertGtContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertGtContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertGtDecimalContractFunction0(ContractFunction):
    """ContractFunction for the assertGtDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertGtDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertGtDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGtDecimalContractFunction1(ContractFunction):
    """ContractFunction for the assertGtDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertGtDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertGtDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGtDecimalContractFunction2(ContractFunction):
    """ContractFunction for the assertGtDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertGtDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertGtDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGtDecimalContractFunction3(ContractFunction):
    """ContractFunction for the assertGtDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertGtDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertGtDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertGtDecimalContractFunction(ContractFunction):
    """ContractFunction for the assertGtDecimal method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertGtDecimalContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertGtDecimalContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertGtDecimalContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertGtDecimalContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertGtDecimalContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertLeContractFunction0(ContractFunction):
    """ContractFunction for the assertLe method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertLeContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertLeContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLeContractFunction1(ContractFunction):
    """ContractFunction for the assertLe method."""

    def __call__(self, left: int, right: int) -> VmAssertLeContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertLeContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLeContractFunction2(ContractFunction):
    """ContractFunction for the assertLe method."""

    def __call__(self, left: int, right: int) -> VmAssertLeContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertLeContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLeContractFunction3(ContractFunction):
    """ContractFunction for the assertLe method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertLeContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertLeContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLeContractFunction(ContractFunction):
    """ContractFunction for the assertLe method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertLeContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int) -> VmAssertLeContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int) -> VmAssertLeContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertLeContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertLeContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertLeDecimalContractFunction0(ContractFunction):
    """ContractFunction for the assertLeDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertLeDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertLeDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLeDecimalContractFunction1(ContractFunction):
    """ContractFunction for the assertLeDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertLeDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertLeDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLeDecimalContractFunction2(ContractFunction):
    """ContractFunction for the assertLeDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertLeDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertLeDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLeDecimalContractFunction3(ContractFunction):
    """ContractFunction for the assertLeDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertLeDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertLeDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLeDecimalContractFunction(ContractFunction):
    """ContractFunction for the assertLeDecimal method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertLeDecimalContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertLeDecimalContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertLeDecimalContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertLeDecimalContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertLeDecimalContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertLtContractFunction0(ContractFunction):
    """ContractFunction for the assertLt method."""

    def __call__(self, left: int, right: int) -> VmAssertLtContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertLtContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLtContractFunction1(ContractFunction):
    """ContractFunction for the assertLt method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertLtContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertLtContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLtContractFunction2(ContractFunction):
    """ContractFunction for the assertLt method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertLtContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertLtContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLtContractFunction3(ContractFunction):
    """ContractFunction for the assertLt method."""

    def __call__(self, left: int, right: int) -> VmAssertLtContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertLtContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLtContractFunction(ContractFunction):
    """ContractFunction for the assertLt method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int) -> VmAssertLtContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertLtContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertLtContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int) -> VmAssertLtContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertLtContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertLtDecimalContractFunction0(ContractFunction):
    """ContractFunction for the assertLtDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertLtDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertLtDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLtDecimalContractFunction1(ContractFunction):
    """ContractFunction for the assertLtDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertLtDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertLtDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLtDecimalContractFunction2(ContractFunction):
    """ContractFunction for the assertLtDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertLtDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertLtDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLtDecimalContractFunction3(ContractFunction):
    """ContractFunction for the assertLtDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertLtDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertLtDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertLtDecimalContractFunction(ContractFunction):
    """ContractFunction for the assertLtDecimal method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertLtDecimalContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertLtDecimalContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertLtDecimalContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertLtDecimalContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertLtDecimalContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertNotEqContractFunction0(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[bytes], right: list[bytes]) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction1(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[int], right: list[int]) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction2(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: bool, right: bool, error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction3(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[bytes], right: list[bytes], error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction4(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: bool, right: bool) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction5(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[bool], right: list[bool]) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction6(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: bytes, right: bytes) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction7(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[str], right: list[str]) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction8(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction9(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[int], right: list[int]) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction10(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[bool], right: list[bool], error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction11(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: str, right: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction12(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[str], right: list[str], error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction13(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: str, right: str, error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction14(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: str, right: str, error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction15(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: bytes, right: bytes) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction16(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: bytes, right: bytes, error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction17(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: int, right: int, error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction18(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[int], right: list[int], error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction19(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: str, right: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction20(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: bytes, right: bytes, error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction21(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[str], right: list[str], error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction22(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: int, right: int) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction23(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[bytes], right: list[bytes], error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction24(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[str], right: list[str]) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction25(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[int], right: list[int], error: str) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction26(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: list[bytes], right: list[bytes]) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction27(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    def __call__(self, left: int, right: int) -> VmAssertNotEqContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right))  # type: ignore
        return cast(VmAssertNotEqContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqContractFunction(ContractFunction):
    """ContractFunction for the assertNotEq method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: list[bytes], right: list[bytes]) -> VmAssertNotEqContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[int], right: list[int]) -> VmAssertNotEqContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: bool, right: bool, error: str) -> VmAssertNotEqContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bytes], right: list[bytes], error: str) -> VmAssertNotEqContractFunction3:  # type: ignore
        ...

    @overload
    def __call__(self, left: bool, right: bool) -> VmAssertNotEqContractFunction4:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bool], right: list[bool]) -> VmAssertNotEqContractFunction5:  # type: ignore
        ...

    @overload
    def __call__(self, left: bytes, right: bytes) -> VmAssertNotEqContractFunction6:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[str], right: list[str]) -> VmAssertNotEqContractFunction7:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertNotEqContractFunction8:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[int], right: list[int]) -> VmAssertNotEqContractFunction9:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bool], right: list[bool], error: str) -> VmAssertNotEqContractFunction10:  # type: ignore
        ...

    @overload
    def __call__(self, left: str, right: str) -> VmAssertNotEqContractFunction11:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[str], right: list[str], error: str) -> VmAssertNotEqContractFunction12:  # type: ignore
        ...

    @overload
    def __call__(self, left: str, right: str, error: str) -> VmAssertNotEqContractFunction13:  # type: ignore
        ...

    @overload
    def __call__(self, left: str, right: str, error: str) -> VmAssertNotEqContractFunction14:  # type: ignore
        ...

    @overload
    def __call__(self, left: bytes, right: bytes) -> VmAssertNotEqContractFunction15:  # type: ignore
        ...

    @overload
    def __call__(self, left: bytes, right: bytes, error: str) -> VmAssertNotEqContractFunction16:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, error: str) -> VmAssertNotEqContractFunction17:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[int], right: list[int], error: str) -> VmAssertNotEqContractFunction18:  # type: ignore
        ...

    @overload
    def __call__(self, left: str, right: str) -> VmAssertNotEqContractFunction19:  # type: ignore
        ...

    @overload
    def __call__(self, left: bytes, right: bytes, error: str) -> VmAssertNotEqContractFunction20:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[str], right: list[str], error: str) -> VmAssertNotEqContractFunction21:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int) -> VmAssertNotEqContractFunction22:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bytes], right: list[bytes], error: str) -> VmAssertNotEqContractFunction23:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[str], right: list[str]) -> VmAssertNotEqContractFunction24:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[int], right: list[int], error: str) -> VmAssertNotEqContractFunction25:  # type: ignore
        ...

    @overload
    def __call__(self, left: list[bytes], right: list[bytes]) -> VmAssertNotEqContractFunction26:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int) -> VmAssertNotEqContractFunction27:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertNotEqContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertNotEqDecimalContractFunction0(ContractFunction):
    """ContractFunction for the assertNotEqDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertNotEqDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertNotEqDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqDecimalContractFunction1(ContractFunction):
    """ContractFunction for the assertNotEqDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertNotEqDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqDecimalContractFunction2(ContractFunction):
    """ContractFunction for the assertNotEqDecimal method."""

    def __call__(self, left: int, right: int, decimals: int) -> VmAssertNotEqDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals))  # type: ignore
        return cast(VmAssertNotEqDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqDecimalContractFunction3(ContractFunction):
    """ContractFunction for the assertNotEqDecimal method."""

    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertNotEqDecimalContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(left), dataclass_to_tuple(right), dataclass_to_tuple(decimals), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertNotEqDecimalContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertNotEqDecimalContractFunction(ContractFunction):
    """ContractFunction for the assertNotEqDecimal method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertNotEqDecimalContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertNotEqDecimalContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int) -> VmAssertNotEqDecimalContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, left: int, right: int, decimals: int, error: str) -> VmAssertNotEqDecimalContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertNotEqDecimalContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssertTrueContractFunction0(ContractFunction):
    """ContractFunction for the assertTrue method."""

    def __call__(self, condition: bool) -> VmAssertTrueContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmAssertTrueContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertTrueContractFunction1(ContractFunction):
    """ContractFunction for the assertTrue method."""

    def __call__(self, condition: bool, error: str) -> VmAssertTrueContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(condition), dataclass_to_tuple(error))  # type: ignore
        return cast(VmAssertTrueContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmAssertTrueContractFunction(ContractFunction):
    """ContractFunction for the assertTrue method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, condition: bool) -> VmAssertTrueContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, condition: bool, error: str) -> VmAssertTrueContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmAssertTrueContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmAssumeContractFunction(ContractFunction):
    """ContractFunction for the assume method."""

    def __call__(self, condition: bool) -> VmAssumeContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(condition))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmBreakpointContractFunction0(ContractFunction):
    """ContractFunction for the breakpoint method."""

    def __call__(self, char: str) -> VmBreakpointContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmBreakpointContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmBreakpointContractFunction1(ContractFunction):
    """ContractFunction for the breakpoint method."""

    def __call__(self, char: str, value: bool) -> VmBreakpointContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(char), dataclass_to_tuple(value))  # type: ignore
        return cast(VmBreakpointContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmBreakpointContractFunction(ContractFunction):
    """ContractFunction for the breakpoint method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, char: str) -> VmBreakpointContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, char: str, value: bool) -> VmBreakpointContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmBreakpointContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmBroadcastContractFunction0(ContractFunction):
    """ContractFunction for the broadcast method."""

    def __call__(self) -> VmBroadcastContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmBroadcastContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmBroadcastContractFunction1(ContractFunction):
    """ContractFunction for the broadcast method."""

    def __call__(self, signer: str) -> VmBroadcastContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmBroadcastContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmBroadcastContractFunction2(ContractFunction):
    """ContractFunction for the broadcast method."""

    def __call__(self, privateKey: int) -> VmBroadcastContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmBroadcastContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmBroadcastContractFunction(ContractFunction):
    """ContractFunction for the broadcast method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self) -> VmBroadcastContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, signer: str) -> VmBroadcastContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, privateKey: int) -> VmBroadcastContractFunction2:  # type: ignore
        ...

    def __call__(self, *args) -> VmBroadcastContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmChainIdContractFunction(ContractFunction):
    """ContractFunction for the chainId method."""

    def __call__(self, newChainId: int) -> VmChainIdContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(newChainId))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmClearMockedCallsContractFunction(ContractFunction):
    """ContractFunction for the clearMockedCalls method."""

    def __call__(self) -> VmClearMockedCallsContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmCloseFileContractFunction(ContractFunction):
    """ContractFunction for the closeFile method."""

    def __call__(self, path: str) -> VmCloseFileContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(path))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmCoinbaseContractFunction(ContractFunction):
    """ContractFunction for the coinbase method."""

    def __call__(self, newCoinbase: str) -> VmCoinbaseContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(newCoinbase))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmComputeCreate2AddressContractFunction0(ContractFunction):
    """ContractFunction for the computeCreate2Address method."""

    def __call__(self, salt: bytes, initCodeHash: bytes) -> VmComputeCreate2AddressContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(salt), dataclass_to_tuple(initCodeHash))  # type: ignore
        return cast(VmComputeCreate2AddressContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmComputeCreate2AddressContractFunction1(ContractFunction):
    """ContractFunction for the computeCreate2Address method."""

    def __call__(self, salt: bytes, initCodeHash: bytes, deployer: str) -> VmComputeCreate2AddressContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(salt), dataclass_to_tuple(initCodeHash), dataclass_to_tuple(deployer))  # type: ignore
        return cast(VmComputeCreate2AddressContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmComputeCreate2AddressContractFunction(ContractFunction):
    """ContractFunction for the computeCreate2Address method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, salt: bytes, initCodeHash: bytes) -> VmComputeCreate2AddressContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, salt: bytes, initCodeHash: bytes, deployer: str) -> VmComputeCreate2AddressContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmComputeCreate2AddressContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmComputeCreateAddressContractFunction(ContractFunction):
    """ContractFunction for the computeCreateAddress method."""

    def __call__(self, deployer: str, nonce: int) -> VmComputeCreateAddressContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(deployer), dataclass_to_tuple(nonce)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmCopyFileContractFunction(ContractFunction):
    """ContractFunction for the copyFile method."""

    def __call__(self, _from: str, to: str) -> VmCopyFileContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(_from), dataclass_to_tuple(to)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateDirContractFunction(ContractFunction):
    """ContractFunction for the createDir method."""

    def __call__(self, path: str, recursive: bool) -> VmCreateDirContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(path), dataclass_to_tuple(recursive)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmCreateForkContractFunction0(ContractFunction):
    """ContractFunction for the createFork method."""

    def __call__(self, urlOrAlias: str) -> VmCreateForkContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmCreateForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateForkContractFunction1(ContractFunction):
    """ContractFunction for the createFork method."""

    def __call__(self, urlOrAlias: str, blockNumber: int) -> VmCreateForkContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(urlOrAlias), dataclass_to_tuple(blockNumber))  # type: ignore
        return cast(VmCreateForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateForkContractFunction2(ContractFunction):
    """ContractFunction for the createFork method."""

    def __call__(self, urlOrAlias: str, txHash: bytes) -> VmCreateForkContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(urlOrAlias), dataclass_to_tuple(txHash))  # type: ignore
        return cast(VmCreateForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateForkContractFunction(ContractFunction):
    """ContractFunction for the createFork method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, urlOrAlias: str) -> VmCreateForkContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, urlOrAlias: str, blockNumber: int) -> VmCreateForkContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, urlOrAlias: str, txHash: bytes) -> VmCreateForkContractFunction2:  # type: ignore
        ...

    def __call__(self, *args) -> VmCreateForkContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmCreateSelectForkContractFunction0(ContractFunction):
    """ContractFunction for the createSelectFork method."""

    def __call__(self, urlOrAlias: str, blockNumber: int) -> VmCreateSelectForkContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(urlOrAlias), dataclass_to_tuple(blockNumber))  # type: ignore
        return cast(VmCreateSelectForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateSelectForkContractFunction1(ContractFunction):
    """ContractFunction for the createSelectFork method."""

    def __call__(self, urlOrAlias: str, txHash: bytes) -> VmCreateSelectForkContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(urlOrAlias), dataclass_to_tuple(txHash))  # type: ignore
        return cast(VmCreateSelectForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateSelectForkContractFunction2(ContractFunction):
    """ContractFunction for the createSelectFork method."""

    def __call__(self, urlOrAlias: str) -> VmCreateSelectForkContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmCreateSelectForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateSelectForkContractFunction(ContractFunction):
    """ContractFunction for the createSelectFork method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, urlOrAlias: str, blockNumber: int) -> VmCreateSelectForkContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, urlOrAlias: str, txHash: bytes) -> VmCreateSelectForkContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, urlOrAlias: str) -> VmCreateSelectForkContractFunction2:  # type: ignore
        ...

    def __call__(self, *args) -> VmCreateSelectForkContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmCreateWalletContractFunction0(ContractFunction):
    """ContractFunction for the createWallet method."""

    def __call__(self, walletLabel: str) -> VmCreateWalletContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmCreateWalletContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> Wallet:
        """returns Wallet."""
        # Define the expected return types from the smart contract call

        return_types = Wallet

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            Wallet, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateWalletContractFunction1(ContractFunction):
    """ContractFunction for the createWallet method."""

    def __call__(self, privateKey: int) -> VmCreateWalletContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmCreateWalletContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> Wallet:
        """returns Wallet."""
        # Define the expected return types from the smart contract call

        return_types = Wallet

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            Wallet, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateWalletContractFunction2(ContractFunction):
    """ContractFunction for the createWallet method."""

    def __call__(self, privateKey: int, walletLabel: str) -> VmCreateWalletContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(privateKey), dataclass_to_tuple(walletLabel))  # type: ignore
        return cast(VmCreateWalletContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> Wallet:
        """returns Wallet."""
        # Define the expected return types from the smart contract call

        return_types = Wallet

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            Wallet, rename_returned_types(structs, return_types, raw_values)
        )


class VmCreateWalletContractFunction(ContractFunction):
    """ContractFunction for the createWallet method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, walletLabel: str) -> VmCreateWalletContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, privateKey: int) -> VmCreateWalletContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, privateKey: int, walletLabel: str) -> VmCreateWalletContractFunction2:  # type: ignore
        ...

    def __call__(self, *args) -> VmCreateWalletContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmDealContractFunction(ContractFunction):
    """ContractFunction for the deal method."""

    def __call__(self, account: str, newBalance: int) -> VmDealContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(account), dataclass_to_tuple(newBalance)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmDeleteSnapshotContractFunction(ContractFunction):
    """ContractFunction for the deleteSnapshot method."""

    def __call__(self, snapshotId: int) -> VmDeleteSnapshotContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(snapshotId))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmDeleteSnapshotsContractFunction(ContractFunction):
    """ContractFunction for the deleteSnapshots method."""

    def __call__(self) -> VmDeleteSnapshotsContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmDeriveKeyContractFunction0(ContractFunction):
    """ContractFunction for the deriveKey method."""

    def __call__(self, mnemonic: str, derivationPath: str, index: int, language: str) -> VmDeriveKeyContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(mnemonic), dataclass_to_tuple(derivationPath), dataclass_to_tuple(index), dataclass_to_tuple(language))  # type: ignore
        return cast(VmDeriveKeyContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmDeriveKeyContractFunction1(ContractFunction):
    """ContractFunction for the deriveKey method."""

    def __call__(self, mnemonic: str, index: int, language: str) -> VmDeriveKeyContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(mnemonic), dataclass_to_tuple(index), dataclass_to_tuple(language))  # type: ignore
        return cast(VmDeriveKeyContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmDeriveKeyContractFunction2(ContractFunction):
    """ContractFunction for the deriveKey method."""

    def __call__(self, mnemonic: str, index: int) -> VmDeriveKeyContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(mnemonic), dataclass_to_tuple(index))  # type: ignore
        return cast(VmDeriveKeyContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmDeriveKeyContractFunction3(ContractFunction):
    """ContractFunction for the deriveKey method."""

    def __call__(self, mnemonic: str, derivationPath: str, index: int) -> VmDeriveKeyContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(mnemonic), dataclass_to_tuple(derivationPath), dataclass_to_tuple(index))  # type: ignore
        return cast(VmDeriveKeyContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmDeriveKeyContractFunction(ContractFunction):
    """ContractFunction for the deriveKey method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, mnemonic: str, derivationPath: str, index: int, language: str) -> VmDeriveKeyContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, mnemonic: str, index: int, language: str) -> VmDeriveKeyContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, mnemonic: str, index: int) -> VmDeriveKeyContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, mnemonic: str, derivationPath: str, index: int) -> VmDeriveKeyContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmDeriveKeyContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmDifficultyContractFunction(ContractFunction):
    """ContractFunction for the difficulty method."""

    def __call__(self, newDifficulty: int) -> VmDifficultyContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(newDifficulty))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmDumpStateContractFunction(ContractFunction):
    """ContractFunction for the dumpState method."""

    def __call__(self, pathToStateJson: str) -> VmDumpStateContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(pathToStateJson))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmEnvAddressContractFunction0(ContractFunction):
    """ContractFunction for the envAddress method."""

    def __call__(self, name: str) -> VmEnvAddressContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmEnvAddressContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvAddressContractFunction1(ContractFunction):
    """ContractFunction for the envAddress method."""

    def __call__(self, name: str, delim: str) -> VmEnvAddressContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim))  # type: ignore
        return cast(VmEnvAddressContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvAddressContractFunction(ContractFunction):
    """ContractFunction for the envAddress method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, name: str) -> VmEnvAddressContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str) -> VmEnvAddressContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmEnvAddressContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmEnvBoolContractFunction0(ContractFunction):
    """ContractFunction for the envBool method."""

    def __call__(self, name: str) -> VmEnvBoolContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmEnvBoolContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvBoolContractFunction1(ContractFunction):
    """ContractFunction for the envBool method."""

    def __call__(self, name: str, delim: str) -> VmEnvBoolContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim))  # type: ignore
        return cast(VmEnvBoolContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bool]:
        """returns list[bool]."""
        # Define the expected return types from the smart contract call

        return_types = list[bool]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[bool], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvBoolContractFunction(ContractFunction):
    """ContractFunction for the envBool method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, name: str) -> VmEnvBoolContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str) -> VmEnvBoolContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmEnvBoolContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmEnvBytesContractFunction0(ContractFunction):
    """ContractFunction for the envBytes method."""

    def __call__(self, name: str) -> VmEnvBytesContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmEnvBytesContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvBytesContractFunction1(ContractFunction):
    """ContractFunction for the envBytes method."""

    def __call__(self, name: str, delim: str) -> VmEnvBytesContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim))  # type: ignore
        return cast(VmEnvBytesContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bytes]:
        """returns list[bytes]."""
        # Define the expected return types from the smart contract call

        return_types = list[bytes]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[bytes],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmEnvBytesContractFunction(ContractFunction):
    """ContractFunction for the envBytes method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, name: str) -> VmEnvBytesContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str) -> VmEnvBytesContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmEnvBytesContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmEnvBytes32ContractFunction0(ContractFunction):
    """ContractFunction for the envBytes32 method."""

    def __call__(self, name: str, delim: str) -> VmEnvBytes32ContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim))  # type: ignore
        return cast(VmEnvBytes32ContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bytes]:
        """returns list[bytes]."""
        # Define the expected return types from the smart contract call

        return_types = list[bytes]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[bytes],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmEnvBytes32ContractFunction1(ContractFunction):
    """ContractFunction for the envBytes32 method."""

    def __call__(self, name: str) -> VmEnvBytes32ContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmEnvBytes32ContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvBytes32ContractFunction(ContractFunction):
    """ContractFunction for the envBytes32 method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, name: str, delim: str) -> VmEnvBytes32ContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, name: str) -> VmEnvBytes32ContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmEnvBytes32ContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmEnvIntContractFunction0(ContractFunction):
    """ContractFunction for the envInt method."""

    def __call__(self, name: str, delim: str) -> VmEnvIntContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim))  # type: ignore
        return cast(VmEnvIntContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[int]:
        """returns list[int]."""
        # Define the expected return types from the smart contract call

        return_types = list[int]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[int], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvIntContractFunction1(ContractFunction):
    """ContractFunction for the envInt method."""

    def __call__(self, name: str) -> VmEnvIntContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmEnvIntContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvIntContractFunction(ContractFunction):
    """ContractFunction for the envInt method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, name: str, delim: str) -> VmEnvIntContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, name: str) -> VmEnvIntContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmEnvIntContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmEnvOrContractFunction0(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, delim: str, defaultValue: list[bytes]) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bytes]:
        """returns list[bytes]."""
        # Define the expected return types from the smart contract call

        return_types = list[bytes]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[bytes],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmEnvOrContractFunction1(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, delim: str, defaultValue: list[int]) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[int]:
        """returns list[int]."""
        # Define the expected return types from the smart contract call

        return_types = list[int]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[int], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction2(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, defaultValue: bool) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction3(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, defaultValue: str) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction4(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, defaultValue: int) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction5(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, delim: str, defaultValue: list[bytes]) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bytes]:
        """returns list[bytes]."""
        # Define the expected return types from the smart contract call

        return_types = list[bytes]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[bytes],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmEnvOrContractFunction6(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, delim: str, defaultValue: list[int]) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[int]:
        """returns list[int]."""
        # Define the expected return types from the smart contract call

        return_types = list[int]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[int], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction7(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, delim: str, defaultValue: list[str]) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction8(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, defaultValue: bytes) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction9(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, defaultValue: bytes) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction10(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, defaultValue: int) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction11(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, delim: str, defaultValue: list[str]) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction12(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, defaultValue: str) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction13(ContractFunction):
    """ContractFunction for the envOr method."""

    def __call__(self, name: str, delim: str, defaultValue: list[bool]) -> VmEnvOrContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim), dataclass_to_tuple(defaultValue))  # type: ignore
        return cast(VmEnvOrContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bool]:
        """returns list[bool]."""
        # Define the expected return types from the smart contract call

        return_types = list[bool]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[bool], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvOrContractFunction(ContractFunction):
    """ContractFunction for the envOr method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, name: str, delim: str, defaultValue: list[bytes]) -> VmEnvOrContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str, defaultValue: list[int]) -> VmEnvOrContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, defaultValue: bool) -> VmEnvOrContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, defaultValue: str) -> VmEnvOrContractFunction3:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, defaultValue: int) -> VmEnvOrContractFunction4:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str, defaultValue: list[bytes]) -> VmEnvOrContractFunction5:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str, defaultValue: list[int]) -> VmEnvOrContractFunction6:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str, defaultValue: list[str]) -> VmEnvOrContractFunction7:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, defaultValue: bytes) -> VmEnvOrContractFunction8:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, defaultValue: bytes) -> VmEnvOrContractFunction9:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, defaultValue: int) -> VmEnvOrContractFunction10:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str, defaultValue: list[str]) -> VmEnvOrContractFunction11:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, defaultValue: str) -> VmEnvOrContractFunction12:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str, defaultValue: list[bool]) -> VmEnvOrContractFunction13:  # type: ignore
        ...

    def __call__(self, *args) -> VmEnvOrContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmEnvStringContractFunction0(ContractFunction):
    """ContractFunction for the envString method."""

    def __call__(self, name: str, delim: str) -> VmEnvStringContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim))  # type: ignore
        return cast(VmEnvStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvStringContractFunction1(ContractFunction):
    """ContractFunction for the envString method."""

    def __call__(self, name: str) -> VmEnvStringContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmEnvStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvStringContractFunction(ContractFunction):
    """ContractFunction for the envString method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, name: str, delim: str) -> VmEnvStringContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, name: str) -> VmEnvStringContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmEnvStringContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmEnvUintContractFunction0(ContractFunction):
    """ContractFunction for the envUint method."""

    def __call__(self, name: str) -> VmEnvUintContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmEnvUintContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvUintContractFunction1(ContractFunction):
    """ContractFunction for the envUint method."""

    def __call__(self, name: str, delim: str) -> VmEnvUintContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(name), dataclass_to_tuple(delim))  # type: ignore
        return cast(VmEnvUintContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[int]:
        """returns list[int]."""
        # Define the expected return types from the smart contract call

        return_types = list[int]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[int], rename_returned_types(structs, return_types, raw_values)
        )


class VmEnvUintContractFunction(ContractFunction):
    """ContractFunction for the envUint method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, name: str) -> VmEnvUintContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, name: str, delim: str) -> VmEnvUintContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmEnvUintContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmEtchContractFunction(ContractFunction):
    """ContractFunction for the etch method."""

    def __call__(self, target: str, newRuntimeBytecode: bytes) -> VmEtchContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(target), dataclass_to_tuple(newRuntimeBytecode)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmEth_getLogsContractFunction(ContractFunction):
    """ContractFunction for the eth_getLogs method."""

    def __call__(self, fromBlock: int, toBlock: int, target: str, topics: list[bytes]) -> VmEth_getLogsContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(fromBlock),
            dataclass_to_tuple(toBlock),
            dataclass_to_tuple(target),
            dataclass_to_tuple(topics),
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[EthGetLogs]:
        """returns list[EthGetLogs]."""
        # Define the expected return types from the smart contract call

        return_types = list[EthGetLogs]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[EthGetLogs],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmExistsContractFunction(ContractFunction):
    """ContractFunction for the exists method."""

    def __call__(self, path: str) -> VmExistsContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(path))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmExpectCallContractFunction0(ContractFunction):
    """ContractFunction for the expectCall method."""

    def __call__(self, callee: str, msgValue: int, gas: int, data: bytes) -> VmExpectCallContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(msgValue), dataclass_to_tuple(gas), dataclass_to_tuple(data))  # type: ignore
        return cast(VmExpectCallContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectCallContractFunction1(ContractFunction):
    """ContractFunction for the expectCall method."""

    def __call__(self, callee: str, msgValue: int, gas: int, data: bytes, count: int) -> VmExpectCallContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(msgValue), dataclass_to_tuple(gas), dataclass_to_tuple(data), dataclass_to_tuple(count))  # type: ignore
        return cast(VmExpectCallContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectCallContractFunction2(ContractFunction):
    """ContractFunction for the expectCall method."""

    def __call__(self, callee: str, msgValue: int, data: bytes, count: int) -> VmExpectCallContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(msgValue), dataclass_to_tuple(data), dataclass_to_tuple(count))  # type: ignore
        return cast(VmExpectCallContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectCallContractFunction3(ContractFunction):
    """ContractFunction for the expectCall method."""

    def __call__(self, callee: str, data: bytes) -> VmExpectCallContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(data))  # type: ignore
        return cast(VmExpectCallContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectCallContractFunction4(ContractFunction):
    """ContractFunction for the expectCall method."""

    def __call__(self, callee: str, data: bytes, count: int) -> VmExpectCallContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(data), dataclass_to_tuple(count))  # type: ignore
        return cast(VmExpectCallContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectCallContractFunction5(ContractFunction):
    """ContractFunction for the expectCall method."""

    def __call__(self, callee: str, msgValue: int, data: bytes) -> VmExpectCallContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(msgValue), dataclass_to_tuple(data))  # type: ignore
        return cast(VmExpectCallContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectCallContractFunction(ContractFunction):
    """ContractFunction for the expectCall method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, callee: str, msgValue: int, gas: int, data: bytes) -> VmExpectCallContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, callee: str, msgValue: int, gas: int, data: bytes, count: int) -> VmExpectCallContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, callee: str, msgValue: int, data: bytes, count: int) -> VmExpectCallContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, callee: str, data: bytes) -> VmExpectCallContractFunction3:  # type: ignore
        ...

    @overload
    def __call__(self, callee: str, data: bytes, count: int) -> VmExpectCallContractFunction4:  # type: ignore
        ...

    @overload
    def __call__(self, callee: str, msgValue: int, data: bytes) -> VmExpectCallContractFunction5:  # type: ignore
        ...

    def __call__(self, *args) -> VmExpectCallContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmExpectCallMinGasContractFunction0(ContractFunction):
    """ContractFunction for the expectCallMinGas method."""

    def __call__(self, callee: str, msgValue: int, minGas: int, data: bytes) -> VmExpectCallMinGasContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(msgValue), dataclass_to_tuple(minGas), dataclass_to_tuple(data))  # type: ignore
        return cast(VmExpectCallMinGasContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectCallMinGasContractFunction1(ContractFunction):
    """ContractFunction for the expectCallMinGas method."""

    def __call__(self, callee: str, msgValue: int, minGas: int, data: bytes, count: int) -> VmExpectCallMinGasContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(msgValue), dataclass_to_tuple(minGas), dataclass_to_tuple(data), dataclass_to_tuple(count))  # type: ignore
        return cast(VmExpectCallMinGasContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectCallMinGasContractFunction(ContractFunction):
    """ContractFunction for the expectCallMinGas method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, callee: str, msgValue: int, minGas: int, data: bytes) -> VmExpectCallMinGasContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, callee: str, msgValue: int, minGas: int, data: bytes, count: int) -> VmExpectCallMinGasContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmExpectCallMinGasContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmExpectEmitContractFunction0(ContractFunction):
    """ContractFunction for the expectEmit method."""

    def __call__(self) -> VmExpectEmitContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmExpectEmitContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectEmitContractFunction1(ContractFunction):
    """ContractFunction for the expectEmit method."""

    def __call__(self, checkTopic1: bool, checkTopic2: bool, checkTopic3: bool, checkData: bool) -> VmExpectEmitContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(checkTopic1), dataclass_to_tuple(checkTopic2), dataclass_to_tuple(checkTopic3), dataclass_to_tuple(checkData))  # type: ignore
        return cast(VmExpectEmitContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectEmitContractFunction2(ContractFunction):
    """ContractFunction for the expectEmit method."""

    def __call__(self, checkTopic1: bool, checkTopic2: bool, checkTopic3: bool, checkData: bool, emitter: str) -> VmExpectEmitContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(checkTopic1), dataclass_to_tuple(checkTopic2), dataclass_to_tuple(checkTopic3), dataclass_to_tuple(checkData), dataclass_to_tuple(emitter))  # type: ignore
        return cast(VmExpectEmitContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectEmitContractFunction3(ContractFunction):
    """ContractFunction for the expectEmit method."""

    def __call__(self, emitter: str) -> VmExpectEmitContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmExpectEmitContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectEmitContractFunction(ContractFunction):
    """ContractFunction for the expectEmit method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self) -> VmExpectEmitContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, checkTopic1: bool, checkTopic2: bool, checkTopic3: bool, checkData: bool) -> VmExpectEmitContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, checkTopic1: bool, checkTopic2: bool, checkTopic3: bool, checkData: bool, emitter: str) -> VmExpectEmitContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, emitter: str) -> VmExpectEmitContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmExpectEmitContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmExpectRevertContractFunction0(ContractFunction):
    """ContractFunction for the expectRevert method."""

    def __call__(self, revertData: bytes) -> VmExpectRevertContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmExpectRevertContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectRevertContractFunction1(ContractFunction):
    """ContractFunction for the expectRevert method."""

    def __call__(self, revertData: bytes) -> VmExpectRevertContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmExpectRevertContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectRevertContractFunction2(ContractFunction):
    """ContractFunction for the expectRevert method."""

    def __call__(self) -> VmExpectRevertContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmExpectRevertContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmExpectRevertContractFunction(ContractFunction):
    """ContractFunction for the expectRevert method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, revertData: bytes) -> VmExpectRevertContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, revertData: bytes) -> VmExpectRevertContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self) -> VmExpectRevertContractFunction2:  # type: ignore
        ...

    def __call__(self, *args) -> VmExpectRevertContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmExpectSafeMemoryContractFunction(ContractFunction):
    """ContractFunction for the expectSafeMemory method."""

    def __call__(self, _min: int, _max: int) -> VmExpectSafeMemoryContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(_min), dataclass_to_tuple(_max)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmExpectSafeMemoryCallContractFunction(ContractFunction):
    """ContractFunction for the expectSafeMemoryCall method."""

    def __call__(self, _min: int, _max: int) -> VmExpectSafeMemoryCallContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(_min), dataclass_to_tuple(_max)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmFeeContractFunction(ContractFunction):
    """ContractFunction for the fee method."""

    def __call__(self, newBasefee: int) -> VmFeeContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(newBasefee))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmFfiContractFunction(ContractFunction):
    """ContractFunction for the ffi method."""

    def __call__(self, commandInput: list[str]) -> VmFfiContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(commandInput))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmFsMetadataContractFunction(ContractFunction):
    """ContractFunction for the fsMetadata method."""

    def __call__(self, path: str) -> VmFsMetadataContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(path))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> FsMetadata:
        """returns FsMetadata."""
        # Define the expected return types from the smart contract call

        return_types = FsMetadata

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            FsMetadata, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetBlockNumberContractFunction(ContractFunction):
    """ContractFunction for the getBlockNumber method."""

    def __call__(self) -> VmGetBlockNumberContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetBlockTimestampContractFunction(ContractFunction):
    """ContractFunction for the getBlockTimestamp method."""

    def __call__(self) -> VmGetBlockTimestampContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetCodeContractFunction(ContractFunction):
    """ContractFunction for the getCode method."""

    def __call__(self, artifactPath: str) -> VmGetCodeContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(artifactPath))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetDeployedCodeContractFunction(ContractFunction):
    """ContractFunction for the getDeployedCode method."""

    def __call__(self, artifactPath: str) -> VmGetDeployedCodeContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(artifactPath))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetLabelContractFunction(ContractFunction):
    """ContractFunction for the getLabel method."""

    def __call__(self, account: str) -> VmGetLabelContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(account))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetMappingKeyAndParentOfContractFunction(ContractFunction):
    """ContractFunction for the getMappingKeyAndParentOf method."""

    class ReturnValues(NamedTuple):
        """The return named tuple for GetMappingKeyAndParentOf."""

        found: bool
        key: bytes
        parent: bytes

    def __call__(self, target: str, elementSlot: bytes) -> VmGetMappingKeyAndParentOfContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(target), dataclass_to_tuple(elementSlot)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> ReturnValues:
        """returns ReturnValues."""
        # Define the expected return types from the smart contract call

        return_types = [bool, bytes, bytes]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return self.ReturnValues(
            *rename_returned_types(structs, return_types, raw_values)
        )


class VmGetMappingLengthContractFunction(ContractFunction):
    """ContractFunction for the getMappingLength method."""

    def __call__(self, target: str, mappingSlot: bytes) -> VmGetMappingLengthContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(target), dataclass_to_tuple(mappingSlot)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetMappingSlotAtContractFunction(ContractFunction):
    """ContractFunction for the getMappingSlotAt method."""

    def __call__(self, target: str, mappingSlot: bytes, idx: int) -> VmGetMappingSlotAtContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(target),
            dataclass_to_tuple(mappingSlot),
            dataclass_to_tuple(idx),
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetNonceContractFunction0(ContractFunction):
    """ContractFunction for the getNonce method."""

    def __call__(self, account: str) -> VmGetNonceContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmGetNonceContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetNonceContractFunction1(ContractFunction):
    """ContractFunction for the getNonce method."""

    def __call__(self, wallet: Wallet) -> VmGetNonceContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmGetNonceContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmGetNonceContractFunction(ContractFunction):
    """ContractFunction for the getNonce method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, account: str) -> VmGetNonceContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, wallet: Wallet) -> VmGetNonceContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmGetNonceContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmGetRecordedLogsContractFunction(ContractFunction):
    """ContractFunction for the getRecordedLogs method."""

    def __call__(self) -> VmGetRecordedLogsContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[Log]:
        """returns list[Log]."""
        # Define the expected return types from the smart contract call

        return_types = list[Log]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[Log], rename_returned_types(structs, return_types, raw_values)
        )


class VmIsDirContractFunction(ContractFunction):
    """ContractFunction for the isDir method."""

    def __call__(self, path: str) -> VmIsDirContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(path))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmIsFileContractFunction(ContractFunction):
    """ContractFunction for the isFile method."""

    def __call__(self, path: str) -> VmIsFileContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(path))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmIsPersistentContractFunction(ContractFunction):
    """ContractFunction for the isPersistent method."""

    def __call__(self, account: str) -> VmIsPersistentContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(account))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmKeyExistsContractFunction(ContractFunction):
    """ContractFunction for the keyExists method."""

    def __call__(self, json: str, key: str) -> VmKeyExistsContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmKeyExistsJsonContractFunction(ContractFunction):
    """ContractFunction for the keyExistsJson method."""

    def __call__(self, json: str, key: str) -> VmKeyExistsJsonContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmKeyExistsTomlContractFunction(ContractFunction):
    """ContractFunction for the keyExistsToml method."""

    def __call__(self, toml: str, key: str) -> VmKeyExistsTomlContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmLabelContractFunction(ContractFunction):
    """ContractFunction for the label method."""

    def __call__(self, account: str, newLabel: str) -> VmLabelContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(account), dataclass_to_tuple(newLabel)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmLoadContractFunction(ContractFunction):
    """ContractFunction for the load method."""

    def __call__(self, target: str, slot: bytes) -> VmLoadContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(target), dataclass_to_tuple(slot)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmLoadAllocsContractFunction(ContractFunction):
    """ContractFunction for the loadAllocs method."""

    def __call__(self, pathToAllocsJson: str) -> VmLoadAllocsContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(pathToAllocsJson))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmMakePersistentContractFunction0(ContractFunction):
    """ContractFunction for the makePersistent method."""

    def __call__(self, accounts: list[str]) -> VmMakePersistentContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmMakePersistentContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmMakePersistentContractFunction1(ContractFunction):
    """ContractFunction for the makePersistent method."""

    def __call__(self, account0: str, account1: str) -> VmMakePersistentContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(account0), dataclass_to_tuple(account1))  # type: ignore
        return cast(VmMakePersistentContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmMakePersistentContractFunction2(ContractFunction):
    """ContractFunction for the makePersistent method."""

    def __call__(self, account: str) -> VmMakePersistentContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmMakePersistentContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmMakePersistentContractFunction3(ContractFunction):
    """ContractFunction for the makePersistent method."""

    def __call__(self, account0: str, account1: str, account2: str) -> VmMakePersistentContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(account0), dataclass_to_tuple(account1), dataclass_to_tuple(account2))  # type: ignore
        return cast(VmMakePersistentContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmMakePersistentContractFunction(ContractFunction):
    """ContractFunction for the makePersistent method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, accounts: list[str]) -> VmMakePersistentContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, account0: str, account1: str) -> VmMakePersistentContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, account: str) -> VmMakePersistentContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, account0: str, account1: str, account2: str) -> VmMakePersistentContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmMakePersistentContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmMockCallContractFunction0(ContractFunction):
    """ContractFunction for the mockCall method."""

    def __call__(self, callee: str, msgValue: int, data: bytes, returnData: bytes) -> VmMockCallContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(msgValue), dataclass_to_tuple(data), dataclass_to_tuple(returnData))  # type: ignore
        return cast(VmMockCallContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmMockCallContractFunction1(ContractFunction):
    """ContractFunction for the mockCall method."""

    def __call__(self, callee: str, data: bytes, returnData: bytes) -> VmMockCallContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(data), dataclass_to_tuple(returnData))  # type: ignore
        return cast(VmMockCallContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmMockCallContractFunction(ContractFunction):
    """ContractFunction for the mockCall method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, callee: str, msgValue: int, data: bytes, returnData: bytes) -> VmMockCallContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, callee: str, data: bytes, returnData: bytes) -> VmMockCallContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmMockCallContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmMockCallRevertContractFunction0(ContractFunction):
    """ContractFunction for the mockCallRevert method."""

    def __call__(self, callee: str, msgValue: int, data: bytes, revertData: bytes) -> VmMockCallRevertContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(msgValue), dataclass_to_tuple(data), dataclass_to_tuple(revertData))  # type: ignore
        return cast(VmMockCallRevertContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmMockCallRevertContractFunction1(ContractFunction):
    """ContractFunction for the mockCallRevert method."""

    def __call__(self, callee: str, data: bytes, revertData: bytes) -> VmMockCallRevertContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(callee), dataclass_to_tuple(data), dataclass_to_tuple(revertData))  # type: ignore
        return cast(VmMockCallRevertContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmMockCallRevertContractFunction(ContractFunction):
    """ContractFunction for the mockCallRevert method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, callee: str, msgValue: int, data: bytes, revertData: bytes) -> VmMockCallRevertContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, callee: str, data: bytes, revertData: bytes) -> VmMockCallRevertContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmMockCallRevertContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmParseAddressContractFunction(ContractFunction):
    """ContractFunction for the parseAddress method."""

    def __call__(self, stringifiedValue: str) -> VmParseAddressContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(stringifiedValue))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseBoolContractFunction(ContractFunction):
    """ContractFunction for the parseBool method."""

    def __call__(self, stringifiedValue: str) -> VmParseBoolContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(stringifiedValue))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseBytesContractFunction(ContractFunction):
    """ContractFunction for the parseBytes method."""

    def __call__(self, stringifiedValue: str) -> VmParseBytesContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(stringifiedValue))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseBytes32ContractFunction(ContractFunction):
    """ContractFunction for the parseBytes32 method."""

    def __call__(self, stringifiedValue: str) -> VmParseBytes32ContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(stringifiedValue))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseIntContractFunction(ContractFunction):
    """ContractFunction for the parseInt method."""

    def __call__(self, stringifiedValue: str) -> VmParseIntContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(stringifiedValue))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonContractFunction0(ContractFunction):
    """ContractFunction for the parseJson method."""

    def __call__(self, json: str) -> VmParseJsonContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmParseJsonContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonContractFunction1(ContractFunction):
    """ContractFunction for the parseJson method."""

    def __call__(self, json: str, key: str) -> VmParseJsonContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(json), dataclass_to_tuple(key))  # type: ignore
        return cast(VmParseJsonContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonContractFunction(ContractFunction):
    """ContractFunction for the parseJson method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, json: str) -> VmParseJsonContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, json: str, key: str) -> VmParseJsonContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmParseJsonContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmParseJsonAddressContractFunction(ContractFunction):
    """ContractFunction for the parseJsonAddress method."""

    def __call__(self, json: str, key: str) -> VmParseJsonAddressContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonAddressArrayContractFunction(ContractFunction):
    """ContractFunction for the parseJsonAddressArray method."""

    def __call__(self, json: str, key: str) -> VmParseJsonAddressArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonBoolContractFunction(ContractFunction):
    """ContractFunction for the parseJsonBool method."""

    def __call__(self, json: str, key: str) -> VmParseJsonBoolContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonBoolArrayContractFunction(ContractFunction):
    """ContractFunction for the parseJsonBoolArray method."""

    def __call__(self, json: str, key: str) -> VmParseJsonBoolArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bool]:
        """returns list[bool]."""
        # Define the expected return types from the smart contract call

        return_types = list[bool]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[bool], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonBytesContractFunction(ContractFunction):
    """ContractFunction for the parseJsonBytes method."""

    def __call__(self, json: str, key: str) -> VmParseJsonBytesContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonBytes32ContractFunction(ContractFunction):
    """ContractFunction for the parseJsonBytes32 method."""

    def __call__(self, json: str, key: str) -> VmParseJsonBytes32ContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonBytes32ArrayContractFunction(ContractFunction):
    """ContractFunction for the parseJsonBytes32Array method."""

    def __call__(self, json: str, key: str) -> VmParseJsonBytes32ArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bytes]:
        """returns list[bytes]."""
        # Define the expected return types from the smart contract call

        return_types = list[bytes]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[bytes],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmParseJsonBytesArrayContractFunction(ContractFunction):
    """ContractFunction for the parseJsonBytesArray method."""

    def __call__(self, json: str, key: str) -> VmParseJsonBytesArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bytes]:
        """returns list[bytes]."""
        # Define the expected return types from the smart contract call

        return_types = list[bytes]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[bytes],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmParseJsonIntContractFunction(ContractFunction):
    """ContractFunction for the parseJsonInt method."""

    def __call__(self, json: str, key: str) -> VmParseJsonIntContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonIntArrayContractFunction(ContractFunction):
    """ContractFunction for the parseJsonIntArray method."""

    def __call__(self, json: str, key: str) -> VmParseJsonIntArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[int]:
        """returns list[int]."""
        # Define the expected return types from the smart contract call

        return_types = list[int]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[int], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonKeysContractFunction(ContractFunction):
    """ContractFunction for the parseJsonKeys method."""

    def __call__(self, json: str, key: str) -> VmParseJsonKeysContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonStringContractFunction(ContractFunction):
    """ContractFunction for the parseJsonString method."""

    def __call__(self, json: str, key: str) -> VmParseJsonStringContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonStringArrayContractFunction(ContractFunction):
    """ContractFunction for the parseJsonStringArray method."""

    def __call__(self, json: str, key: str) -> VmParseJsonStringArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonUintContractFunction(ContractFunction):
    """ContractFunction for the parseJsonUint method."""

    def __call__(self, json: str, key: str) -> VmParseJsonUintContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseJsonUintArrayContractFunction(ContractFunction):
    """ContractFunction for the parseJsonUintArray method."""

    def __call__(self, json: str, key: str) -> VmParseJsonUintArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(json), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[int]:
        """returns list[int]."""
        # Define the expected return types from the smart contract call

        return_types = list[int]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[int], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlContractFunction0(ContractFunction):
    """ContractFunction for the parseToml method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(toml), dataclass_to_tuple(key))  # type: ignore
        return cast(VmParseTomlContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlContractFunction1(ContractFunction):
    """ContractFunction for the parseToml method."""

    def __call__(self, toml: str) -> VmParseTomlContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmParseTomlContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlContractFunction(ContractFunction):
    """ContractFunction for the parseToml method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, toml: str, key: str) -> VmParseTomlContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, toml: str) -> VmParseTomlContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmParseTomlContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmParseTomlAddressContractFunction(ContractFunction):
    """ContractFunction for the parseTomlAddress method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlAddressContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlAddressArrayContractFunction(ContractFunction):
    """ContractFunction for the parseTomlAddressArray method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlAddressArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlBoolContractFunction(ContractFunction):
    """ContractFunction for the parseTomlBool method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlBoolContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlBoolArrayContractFunction(ContractFunction):
    """ContractFunction for the parseTomlBoolArray method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlBoolArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bool]:
        """returns list[bool]."""
        # Define the expected return types from the smart contract call

        return_types = list[bool]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[bool], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlBytesContractFunction(ContractFunction):
    """ContractFunction for the parseTomlBytes method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlBytesContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlBytes32ContractFunction(ContractFunction):
    """ContractFunction for the parseTomlBytes32 method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlBytes32ContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlBytes32ArrayContractFunction(ContractFunction):
    """ContractFunction for the parseTomlBytes32Array method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlBytes32ArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bytes]:
        """returns list[bytes]."""
        # Define the expected return types from the smart contract call

        return_types = list[bytes]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[bytes],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmParseTomlBytesArrayContractFunction(ContractFunction):
    """ContractFunction for the parseTomlBytesArray method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlBytesArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[bytes]:
        """returns list[bytes]."""
        # Define the expected return types from the smart contract call

        return_types = list[bytes]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[bytes],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmParseTomlIntContractFunction(ContractFunction):
    """ContractFunction for the parseTomlInt method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlIntContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlIntArrayContractFunction(ContractFunction):
    """ContractFunction for the parseTomlIntArray method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlIntArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[int]:
        """returns list[int]."""
        # Define the expected return types from the smart contract call

        return_types = list[int]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[int], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlKeysContractFunction(ContractFunction):
    """ContractFunction for the parseTomlKeys method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlKeysContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlStringContractFunction(ContractFunction):
    """ContractFunction for the parseTomlString method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlStringContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlStringArrayContractFunction(ContractFunction):
    """ContractFunction for the parseTomlStringArray method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlStringArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlUintContractFunction(ContractFunction):
    """ContractFunction for the parseTomlUint method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlUintContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmParseTomlUintArrayContractFunction(ContractFunction):
    """ContractFunction for the parseTomlUintArray method."""

    def __call__(self, toml: str, key: str) -> VmParseTomlUintArrayContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(toml), dataclass_to_tuple(key)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[int]:
        """returns list[int]."""
        # Define the expected return types from the smart contract call

        return_types = list[int]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[int], rename_returned_types(structs, return_types, raw_values)
        )


class VmParseUintContractFunction(ContractFunction):
    """ContractFunction for the parseUint method."""

    def __call__(self, stringifiedValue: str) -> VmParseUintContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(stringifiedValue))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmPauseGasMeteringContractFunction(ContractFunction):
    """ContractFunction for the pauseGasMetering method."""

    def __call__(self) -> VmPauseGasMeteringContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmPrankContractFunction0(ContractFunction):
    """ContractFunction for the prank method."""

    def __call__(self, msgSender: str, txOrigin: str) -> VmPrankContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(msgSender), dataclass_to_tuple(txOrigin))  # type: ignore
        return cast(VmPrankContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmPrankContractFunction1(ContractFunction):
    """ContractFunction for the prank method."""

    def __call__(self, msgSender: str) -> VmPrankContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmPrankContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmPrankContractFunction(ContractFunction):
    """ContractFunction for the prank method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, msgSender: str, txOrigin: str) -> VmPrankContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, msgSender: str) -> VmPrankContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmPrankContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmPrevrandaoContractFunction(ContractFunction):
    """ContractFunction for the prevrandao method."""

    def __call__(self, newPrevrandao: bytes) -> VmPrevrandaoContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(newPrevrandao))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmProjectRootContractFunction(ContractFunction):
    """ContractFunction for the projectRoot method."""

    def __call__(self) -> VmProjectRootContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmReadCallersContractFunction(ContractFunction):
    """ContractFunction for the readCallers method."""

    class ReturnValues(NamedTuple):
        """The return named tuple for ReadCallers."""

        callerMode: int
        msgSender: str
        txOrigin: str

    def __call__(self) -> VmReadCallersContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> ReturnValues:
        """returns ReturnValues."""
        # Define the expected return types from the smart contract call

        return_types = [int, str, str]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return self.ReturnValues(
            *rename_returned_types(structs, return_types, raw_values)
        )


class VmReadDirContractFunction0(ContractFunction):
    """ContractFunction for the readDir method."""

    def __call__(self, path: str, maxDepth: int) -> VmReadDirContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(path), dataclass_to_tuple(maxDepth))  # type: ignore
        return cast(VmReadDirContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[DirEntry]:
        """returns list[DirEntry]."""
        # Define the expected return types from the smart contract call

        return_types = list[DirEntry]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[DirEntry],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmReadDirContractFunction1(ContractFunction):
    """ContractFunction for the readDir method."""

    def __call__(self, path: str, maxDepth: int, followLinks: bool) -> VmReadDirContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(path), dataclass_to_tuple(maxDepth), dataclass_to_tuple(followLinks))  # type: ignore
        return cast(VmReadDirContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[DirEntry]:
        """returns list[DirEntry]."""
        # Define the expected return types from the smart contract call

        return_types = list[DirEntry]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[DirEntry],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmReadDirContractFunction2(ContractFunction):
    """ContractFunction for the readDir method."""

    def __call__(self, path: str) -> VmReadDirContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmReadDirContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[DirEntry]:
        """returns list[DirEntry]."""
        # Define the expected return types from the smart contract call

        return_types = list[DirEntry]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            list[DirEntry],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmReadDirContractFunction(ContractFunction):
    """ContractFunction for the readDir method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, path: str, maxDepth: int) -> VmReadDirContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, path: str, maxDepth: int, followLinks: bool) -> VmReadDirContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, path: str) -> VmReadDirContractFunction2:  # type: ignore
        ...

    def __call__(self, *args) -> VmReadDirContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmReadFileContractFunction(ContractFunction):
    """ContractFunction for the readFile method."""

    def __call__(self, path: str) -> VmReadFileContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(path))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmReadFileBinaryContractFunction(ContractFunction):
    """ContractFunction for the readFileBinary method."""

    def __call__(self, path: str) -> VmReadFileBinaryContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(path))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmReadLineContractFunction(ContractFunction):
    """ContractFunction for the readLine method."""

    def __call__(self, path: str) -> VmReadLineContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(path))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmReadLinkContractFunction(ContractFunction):
    """ContractFunction for the readLink method."""

    def __call__(self, linkPath: str) -> VmReadLinkContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(linkPath))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmRecordContractFunction(ContractFunction):
    """ContractFunction for the record method."""

    def __call__(self) -> VmRecordContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmRecordLogsContractFunction(ContractFunction):
    """ContractFunction for the recordLogs method."""

    def __call__(self) -> VmRecordLogsContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmRememberKeyContractFunction(ContractFunction):
    """ContractFunction for the rememberKey method."""

    def __call__(self, privateKey: int) -> VmRememberKeyContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(privateKey))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmRemoveDirContractFunction(ContractFunction):
    """ContractFunction for the removeDir method."""

    def __call__(self, path: str, recursive: bool) -> VmRemoveDirContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(path), dataclass_to_tuple(recursive)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmRemoveFileContractFunction(ContractFunction):
    """ContractFunction for the removeFile method."""

    def __call__(self, path: str) -> VmRemoveFileContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(path))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmReplaceContractFunction(ContractFunction):
    """ContractFunction for the replace method."""

    def __call__(self, _input: str, _from: str, to: str) -> VmReplaceContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(_input),
            dataclass_to_tuple(_from),
            dataclass_to_tuple(to),
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmResetNonceContractFunction(ContractFunction):
    """ContractFunction for the resetNonce method."""

    def __call__(self, account: str) -> VmResetNonceContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(account))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmResumeGasMeteringContractFunction(ContractFunction):
    """ContractFunction for the resumeGasMetering method."""

    def __call__(self) -> VmResumeGasMeteringContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmRevertToContractFunction(ContractFunction):
    """ContractFunction for the revertTo method."""

    def __call__(self, snapshotId: int) -> VmRevertToContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(snapshotId))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmRevertToAndDeleteContractFunction(ContractFunction):
    """ContractFunction for the revertToAndDelete method."""

    def __call__(self, snapshotId: int) -> VmRevertToAndDeleteContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(snapshotId))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bool:
        """returns bool."""
        # Define the expected return types from the smart contract call

        return_types = bool

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bool, rename_returned_types(structs, return_types, raw_values)
        )


class VmRevokePersistentContractFunction0(ContractFunction):
    """ContractFunction for the revokePersistent method."""

    def __call__(self, accounts: list[str]) -> VmRevokePersistentContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmRevokePersistentContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmRevokePersistentContractFunction1(ContractFunction):
    """ContractFunction for the revokePersistent method."""

    def __call__(self, account: str) -> VmRevokePersistentContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmRevokePersistentContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmRevokePersistentContractFunction(ContractFunction):
    """ContractFunction for the revokePersistent method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, accounts: list[str]) -> VmRevokePersistentContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, account: str) -> VmRevokePersistentContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmRevokePersistentContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmRollContractFunction(ContractFunction):
    """ContractFunction for the roll method."""

    def __call__(self, newHeight: int) -> VmRollContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(newHeight))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmRollForkContractFunction0(ContractFunction):
    """ContractFunction for the rollFork method."""

    def __call__(self, txHash: bytes) -> VmRollForkContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmRollForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmRollForkContractFunction1(ContractFunction):
    """ContractFunction for the rollFork method."""

    def __call__(self, forkId: int, blockNumber: int) -> VmRollForkContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(forkId), dataclass_to_tuple(blockNumber))  # type: ignore
        return cast(VmRollForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmRollForkContractFunction2(ContractFunction):
    """ContractFunction for the rollFork method."""

    def __call__(self, blockNumber: int) -> VmRollForkContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmRollForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmRollForkContractFunction3(ContractFunction):
    """ContractFunction for the rollFork method."""

    def __call__(self, forkId: int, txHash: bytes) -> VmRollForkContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(forkId), dataclass_to_tuple(txHash))  # type: ignore
        return cast(VmRollForkContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmRollForkContractFunction(ContractFunction):
    """ContractFunction for the rollFork method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, txHash: bytes) -> VmRollForkContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, forkId: int, blockNumber: int) -> VmRollForkContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, blockNumber: int) -> VmRollForkContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, forkId: int, txHash: bytes) -> VmRollForkContractFunction3:  # type: ignore
        ...

    def __call__(self, *args) -> VmRollForkContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmRpcContractFunction(ContractFunction):
    """ContractFunction for the rpc method."""

    def __call__(self, method: str, params: str) -> VmRpcContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(method), dataclass_to_tuple(params)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> bytes:
        """returns bytes."""
        # Define the expected return types from the smart contract call

        return_types = bytes

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            bytes, rename_returned_types(structs, return_types, raw_values)
        )


class VmRpcUrlContractFunction(ContractFunction):
    """ContractFunction for the rpcUrl method."""

    def __call__(self, rpcAlias: str) -> VmRpcUrlContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(rpcAlias))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmRpcUrlStructsContractFunction(ContractFunction):
    """ContractFunction for the rpcUrlStructs method."""

    def __call__(self) -> VmRpcUrlStructsContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[Rpc]:
        """returns list[Rpc]."""
        # Define the expected return types from the smart contract call

        return_types = list[Rpc]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[Rpc], rename_returned_types(structs, return_types, raw_values)
        )


class VmRpcUrlsContractFunction(ContractFunction):
    """ContractFunction for the rpcUrls method."""

    def __call__(self) -> VmRpcUrlsContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[list[str]]:
        """returns list[list[str]]."""
        # Define the expected return types from the smart contract call

        return_types = list[list[str]]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[list[str]],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmSelectForkContractFunction(ContractFunction):
    """ContractFunction for the selectFork method."""

    def __call__(self, forkId: int) -> VmSelectForkContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(forkId))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmSerializeAddressContractFunction0(ContractFunction):
    """ContractFunction for the serializeAddress method."""

    def __call__(self, objectKey: str, valueKey: str, values: list[str]) -> VmSerializeAddressContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(values))  # type: ignore
        return cast(VmSerializeAddressContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeAddressContractFunction1(ContractFunction):
    """ContractFunction for the serializeAddress method."""

    def __call__(self, objectKey: str, valueKey: str, value: str) -> VmSerializeAddressContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(value))  # type: ignore
        return cast(VmSerializeAddressContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeAddressContractFunction(ContractFunction):
    """ContractFunction for the serializeAddress method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, objectKey: str, valueKey: str, values: list[str]) -> VmSerializeAddressContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, objectKey: str, valueKey: str, value: str) -> VmSerializeAddressContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmSerializeAddressContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmSerializeBoolContractFunction0(ContractFunction):
    """ContractFunction for the serializeBool method."""

    def __call__(self, objectKey: str, valueKey: str, values: list[bool]) -> VmSerializeBoolContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(values))  # type: ignore
        return cast(VmSerializeBoolContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeBoolContractFunction1(ContractFunction):
    """ContractFunction for the serializeBool method."""

    def __call__(self, objectKey: str, valueKey: str, value: bool) -> VmSerializeBoolContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(value))  # type: ignore
        return cast(VmSerializeBoolContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeBoolContractFunction(ContractFunction):
    """ContractFunction for the serializeBool method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, objectKey: str, valueKey: str, values: list[bool]) -> VmSerializeBoolContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, objectKey: str, valueKey: str, value: bool) -> VmSerializeBoolContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmSerializeBoolContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmSerializeBytesContractFunction0(ContractFunction):
    """ContractFunction for the serializeBytes method."""

    def __call__(self, objectKey: str, valueKey: str, values: list[bytes]) -> VmSerializeBytesContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(values))  # type: ignore
        return cast(VmSerializeBytesContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeBytesContractFunction1(ContractFunction):
    """ContractFunction for the serializeBytes method."""

    def __call__(self, objectKey: str, valueKey: str, value: bytes) -> VmSerializeBytesContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(value))  # type: ignore
        return cast(VmSerializeBytesContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeBytesContractFunction(ContractFunction):
    """ContractFunction for the serializeBytes method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, objectKey: str, valueKey: str, values: list[bytes]) -> VmSerializeBytesContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, objectKey: str, valueKey: str, value: bytes) -> VmSerializeBytesContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmSerializeBytesContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmSerializeBytes32ContractFunction0(ContractFunction):
    """ContractFunction for the serializeBytes32 method."""

    def __call__(self, objectKey: str, valueKey: str, values: list[bytes]) -> VmSerializeBytes32ContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(values))  # type: ignore
        return cast(VmSerializeBytes32ContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeBytes32ContractFunction1(ContractFunction):
    """ContractFunction for the serializeBytes32 method."""

    def __call__(self, objectKey: str, valueKey: str, value: bytes) -> VmSerializeBytes32ContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(value))  # type: ignore
        return cast(VmSerializeBytes32ContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeBytes32ContractFunction(ContractFunction):
    """ContractFunction for the serializeBytes32 method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, objectKey: str, valueKey: str, values: list[bytes]) -> VmSerializeBytes32ContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, objectKey: str, valueKey: str, value: bytes) -> VmSerializeBytes32ContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmSerializeBytes32ContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmSerializeIntContractFunction0(ContractFunction):
    """ContractFunction for the serializeInt method."""

    def __call__(self, objectKey: str, valueKey: str, value: int) -> VmSerializeIntContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(value))  # type: ignore
        return cast(VmSerializeIntContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeIntContractFunction1(ContractFunction):
    """ContractFunction for the serializeInt method."""

    def __call__(self, objectKey: str, valueKey: str, values: list[int]) -> VmSerializeIntContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(values))  # type: ignore
        return cast(VmSerializeIntContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeIntContractFunction(ContractFunction):
    """ContractFunction for the serializeInt method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, objectKey: str, valueKey: str, value: int) -> VmSerializeIntContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, objectKey: str, valueKey: str, values: list[int]) -> VmSerializeIntContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmSerializeIntContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmSerializeJsonContractFunction(ContractFunction):
    """ContractFunction for the serializeJson method."""

    def __call__(self, objectKey: str, value: str) -> VmSerializeJsonContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(objectKey), dataclass_to_tuple(value)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeStringContractFunction0(ContractFunction):
    """ContractFunction for the serializeString method."""

    def __call__(self, objectKey: str, valueKey: str, values: list[str]) -> VmSerializeStringContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(values))  # type: ignore
        return cast(VmSerializeStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeStringContractFunction1(ContractFunction):
    """ContractFunction for the serializeString method."""

    def __call__(self, objectKey: str, valueKey: str, value: str) -> VmSerializeStringContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(value))  # type: ignore
        return cast(VmSerializeStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeStringContractFunction(ContractFunction):
    """ContractFunction for the serializeString method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, objectKey: str, valueKey: str, values: list[str]) -> VmSerializeStringContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, objectKey: str, valueKey: str, value: str) -> VmSerializeStringContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmSerializeStringContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmSerializeUintContractFunction0(ContractFunction):
    """ContractFunction for the serializeUint method."""

    def __call__(self, objectKey: str, valueKey: str, value: int) -> VmSerializeUintContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(value))  # type: ignore
        return cast(VmSerializeUintContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeUintContractFunction1(ContractFunction):
    """ContractFunction for the serializeUint method."""

    def __call__(self, objectKey: str, valueKey: str, values: list[int]) -> VmSerializeUintContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(objectKey), dataclass_to_tuple(valueKey), dataclass_to_tuple(values))  # type: ignore
        return cast(VmSerializeUintContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmSerializeUintContractFunction(ContractFunction):
    """ContractFunction for the serializeUint method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, objectKey: str, valueKey: str, value: int) -> VmSerializeUintContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, objectKey: str, valueKey: str, values: list[int]) -> VmSerializeUintContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmSerializeUintContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmSetEnvContractFunction(ContractFunction):
    """ContractFunction for the setEnv method."""

    def __call__(self, name: str, value: str) -> VmSetEnvContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(name), dataclass_to_tuple(value)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmSetNonceContractFunction(ContractFunction):
    """ContractFunction for the setNonce method."""

    def __call__(self, account: str, newNonce: int) -> VmSetNonceContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(account), dataclass_to_tuple(newNonce)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmSetNonceUnsafeContractFunction(ContractFunction):
    """ContractFunction for the setNonceUnsafe method."""

    def __call__(self, account: str, newNonce: int) -> VmSetNonceUnsafeContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(account), dataclass_to_tuple(newNonce)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmSignContractFunction0(ContractFunction):
    """ContractFunction for the sign method."""

    def __call__(self, wallet: Wallet, digest: bytes) -> VmSignContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(wallet), dataclass_to_tuple(digest))  # type: ignore
        return cast(VmSignContractFunction, self)

    class ReturnValues(NamedTuple):
        """The return named tuple for Sign."""

        v: int
        r: bytes
        s: bytes

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> ReturnValues:
        """returns ReturnValues."""
        # Define the expected return types from the smart contract call

        return_types = [int, bytes, bytes]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return self.ReturnValues(
            *rename_returned_types(structs, return_types, raw_values)
        )


class VmSignContractFunction1(ContractFunction):
    """ContractFunction for the sign method."""

    def __call__(self, privateKey: int, digest: bytes) -> VmSignContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(privateKey), dataclass_to_tuple(digest))  # type: ignore
        return cast(VmSignContractFunction, self)

    class ReturnValues(NamedTuple):
        """The return named tuple for Sign."""

        v: int
        r: bytes
        s: bytes

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> ReturnValues:
        """returns ReturnValues."""
        # Define the expected return types from the smart contract call

        return_types = [int, bytes, bytes]

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return self.ReturnValues(
            *rename_returned_types(structs, return_types, raw_values)
        )


class VmSignContractFunction(ContractFunction):
    """ContractFunction for the sign method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, wallet: Wallet, digest: bytes) -> VmSignContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, privateKey: int, digest: bytes) -> VmSignContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmSignContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmSignP256ContractFunction(ContractFunction):
    """ContractFunction for the signP256 method."""

    class ReturnValues(NamedTuple):
        """The return named tuple for SignP256."""

        r: bytes
        s: bytes

    def __call__(self, privateKey: int, digest: bytes) -> VmSignP256ContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(privateKey), dataclass_to_tuple(digest)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> ReturnValues:
        """returns ReturnValues."""
        # Define the expected return types from the smart contract call

        return_types = [bytes, bytes]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return self.ReturnValues(
            *rename_returned_types(structs, return_types, raw_values)
        )


class VmSkipContractFunction(ContractFunction):
    """ContractFunction for the skip method."""

    def __call__(self, skipTest: bool) -> VmSkipContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(skipTest))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmSleepContractFunction(ContractFunction):
    """ContractFunction for the sleep method."""

    def __call__(self, duration: int) -> VmSleepContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(duration))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmSnapshotContractFunction(ContractFunction):
    """ContractFunction for the snapshot method."""

    def __call__(self) -> VmSnapshotContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmSplitContractFunction(ContractFunction):
    """ContractFunction for the split method."""

    def __call__(self, _input: str, delimiter: str) -> VmSplitContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(_input), dataclass_to_tuple(delimiter)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[str]:
        """returns list[str]."""
        # Define the expected return types from the smart contract call

        return_types = list[str]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[str], rename_returned_types(structs, return_types, raw_values)
        )


class VmStartBroadcastContractFunction0(ContractFunction):
    """ContractFunction for the startBroadcast method."""

    def __call__(self) -> VmStartBroadcastContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmStartBroadcastContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmStartBroadcastContractFunction1(ContractFunction):
    """ContractFunction for the startBroadcast method."""

    def __call__(self, signer: str) -> VmStartBroadcastContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmStartBroadcastContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmStartBroadcastContractFunction2(ContractFunction):
    """ContractFunction for the startBroadcast method."""

    def __call__(self, privateKey: int) -> VmStartBroadcastContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmStartBroadcastContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmStartBroadcastContractFunction(ContractFunction):
    """ContractFunction for the startBroadcast method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self) -> VmStartBroadcastContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, signer: str) -> VmStartBroadcastContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, privateKey: int) -> VmStartBroadcastContractFunction2:  # type: ignore
        ...

    def __call__(self, *args) -> VmStartBroadcastContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmStartMappingRecordingContractFunction(ContractFunction):
    """ContractFunction for the startMappingRecording method."""

    def __call__(self) -> VmStartMappingRecordingContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmStartPrankContractFunction0(ContractFunction):
    """ContractFunction for the startPrank method."""

    def __call__(self, msgSender: str) -> VmStartPrankContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmStartPrankContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmStartPrankContractFunction1(ContractFunction):
    """ContractFunction for the startPrank method."""

    def __call__(self, msgSender: str, txOrigin: str) -> VmStartPrankContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(msgSender), dataclass_to_tuple(txOrigin))  # type: ignore
        return cast(VmStartPrankContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmStartPrankContractFunction(ContractFunction):
    """ContractFunction for the startPrank method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, msgSender: str) -> VmStartPrankContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, msgSender: str, txOrigin: str) -> VmStartPrankContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmStartPrankContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmStartStateDiffRecordingContractFunction(ContractFunction):
    """ContractFunction for the startStateDiffRecording method."""

    def __call__(self) -> VmStartStateDiffRecordingContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmStopAndReturnStateDiffContractFunction(ContractFunction):
    """ContractFunction for the stopAndReturnStateDiff method."""

    def __call__(self) -> VmStopAndReturnStateDiffContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> list[AccountAccess]:
        """returns list[AccountAccess]."""
        # Define the expected return types from the smart contract call

        return_types = list[AccountAccess]

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            list[AccountAccess],
            rename_returned_types(structs, return_types, raw_values),
        )


class VmStopBroadcastContractFunction(ContractFunction):
    """ContractFunction for the stopBroadcast method."""

    def __call__(self) -> VmStopBroadcastContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmStopExpectSafeMemoryContractFunction(ContractFunction):
    """ContractFunction for the stopExpectSafeMemory method."""

    def __call__(self) -> VmStopExpectSafeMemoryContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmStopMappingRecordingContractFunction(ContractFunction):
    """ContractFunction for the stopMappingRecording method."""

    def __call__(self) -> VmStopMappingRecordingContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmStopPrankContractFunction(ContractFunction):
    """ContractFunction for the stopPrank method."""

    def __call__(self) -> VmStopPrankContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmStoreContractFunction(ContractFunction):
    """ContractFunction for the store method."""

    def __call__(self, target: str, slot: bytes, value: bytes) -> VmStoreContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(target),
            dataclass_to_tuple(slot),
            dataclass_to_tuple(value),
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmToBase64ContractFunction0(ContractFunction):
    """ContractFunction for the toBase64 method."""

    def __call__(self, data: str) -> VmToBase64ContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToBase64ContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToBase64ContractFunction1(ContractFunction):
    """ContractFunction for the toBase64 method."""

    def __call__(self, data: bytes) -> VmToBase64ContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToBase64ContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToBase64ContractFunction(ContractFunction):
    """ContractFunction for the toBase64 method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, data: str) -> VmToBase64ContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, data: bytes) -> VmToBase64ContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmToBase64ContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmToBase64URLContractFunction0(ContractFunction):
    """ContractFunction for the toBase64URL method."""

    def __call__(self, data: str) -> VmToBase64URLContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToBase64URLContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToBase64URLContractFunction1(ContractFunction):
    """ContractFunction for the toBase64URL method."""

    def __call__(self, data: bytes) -> VmToBase64URLContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToBase64URLContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToBase64URLContractFunction(ContractFunction):
    """ContractFunction for the toBase64URL method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, data: str) -> VmToBase64URLContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, data: bytes) -> VmToBase64URLContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmToBase64URLContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmToLowercaseContractFunction(ContractFunction):
    """ContractFunction for the toLowercase method."""

    def __call__(self, _input: str) -> VmToLowercaseContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(_input))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToStringContractFunction0(ContractFunction):
    """ContractFunction for the toString method."""

    def __call__(self, value: str) -> VmToStringContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToStringContractFunction1(ContractFunction):
    """ContractFunction for the toString method."""

    def __call__(self, value: int) -> VmToStringContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToStringContractFunction2(ContractFunction):
    """ContractFunction for the toString method."""

    def __call__(self, value: bytes) -> VmToStringContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToStringContractFunction3(ContractFunction):
    """ContractFunction for the toString method."""

    def __call__(self, value: bool) -> VmToStringContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToStringContractFunction4(ContractFunction):
    """ContractFunction for the toString method."""

    def __call__(self, value: int) -> VmToStringContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToStringContractFunction5(ContractFunction):
    """ContractFunction for the toString method."""

    def __call__(self, value: bytes) -> VmToStringContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmToStringContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )

        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmToStringContractFunction(ContractFunction):
    """ContractFunction for the toString method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, value: str) -> VmToStringContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, value: int) -> VmToStringContractFunction1:  # type: ignore
        ...

    @overload
    def __call__(self, value: bytes) -> VmToStringContractFunction2:  # type: ignore
        ...

    @overload
    def __call__(self, value: bool) -> VmToStringContractFunction3:  # type: ignore
        ...

    @overload
    def __call__(self, value: int) -> VmToStringContractFunction4:  # type: ignore
        ...

    @overload
    def __call__(self, value: bytes) -> VmToStringContractFunction5:  # type: ignore
        ...

    def __call__(self, *args) -> VmToStringContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmToUppercaseContractFunction(ContractFunction):
    """ContractFunction for the toUppercase method."""

    def __call__(self, _input: str) -> VmToUppercaseContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(_input))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmTransactContractFunction0(ContractFunction):
    """ContractFunction for the transact method."""

    def __call__(self, forkId: int, txHash: bytes) -> VmTransactContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(forkId), dataclass_to_tuple(txHash))  # type: ignore
        return cast(VmTransactContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmTransactContractFunction1(ContractFunction):
    """ContractFunction for the transact method."""

    def __call__(self, txHash: bytes) -> VmTransactContractFunction:  # type: ignore
        super().__call__()  # type: ignore
        return cast(VmTransactContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmTransactContractFunction(ContractFunction):
    """ContractFunction for the transact method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, forkId: int, txHash: bytes) -> VmTransactContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, txHash: bytes) -> VmTransactContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmTransactContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmTrimContractFunction(ContractFunction):
    """ContractFunction for the trim method."""

    def __call__(self, _input: str) -> VmTrimContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(_input))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> str:
        """returns str."""
        # Define the expected return types from the smart contract call

        return_types = str

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            str, rename_returned_types(structs, return_types, raw_values)
        )


class VmTryFfiContractFunction(ContractFunction):
    """ContractFunction for the tryFfi method."""

    def __call__(self, commandInput: list[str]) -> VmTryFfiContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(commandInput))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> FfiResult:
        """returns FfiResult."""
        # Define the expected return types from the smart contract call

        return_types = FfiResult

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            FfiResult, rename_returned_types(structs, return_types, raw_values)
        )


class VmTxGasPriceContractFunction(ContractFunction):
    """ContractFunction for the txGasPrice method."""

    def __call__(self, newGasPrice: int) -> VmTxGasPriceContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(newGasPrice))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmUnixTimeContractFunction(ContractFunction):
    """ContractFunction for the unixTime method."""

    def __call__(self) -> VmUnixTimeContractFunction:  # type: ignore
        clone = super().__call__()
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> int:
        """returns int."""
        # Define the expected return types from the smart contract call

        return_types = int

        # Call the function

        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )
        return cast(
            int, rename_returned_types(structs, return_types, raw_values)
        )


class VmWarpContractFunction(ContractFunction):
    """ContractFunction for the warp method."""

    def __call__(self, newTimestamp: int) -> VmWarpContractFunction:  # type: ignore
        clone = super().__call__(dataclass_to_tuple(newTimestamp))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmWriteFileContractFunction(ContractFunction):
    """ContractFunction for the writeFile method."""

    def __call__(self, path: str, data: str) -> VmWriteFileContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(path), dataclass_to_tuple(data)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmWriteFileBinaryContractFunction(ContractFunction):
    """ContractFunction for the writeFileBinary method."""

    def __call__(self, path: str, data: bytes) -> VmWriteFileBinaryContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(path), dataclass_to_tuple(data)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmWriteJsonContractFunction0(ContractFunction):
    """ContractFunction for the writeJson method."""

    def __call__(self, json: str, path: str, valueKey: str) -> VmWriteJsonContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(json), dataclass_to_tuple(path), dataclass_to_tuple(valueKey))  # type: ignore
        return cast(VmWriteJsonContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmWriteJsonContractFunction1(ContractFunction):
    """ContractFunction for the writeJson method."""

    def __call__(self, json: str, path: str) -> VmWriteJsonContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(json), dataclass_to_tuple(path))  # type: ignore
        return cast(VmWriteJsonContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmWriteJsonContractFunction(ContractFunction):
    """ContractFunction for the writeJson method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, json: str, path: str, valueKey: str) -> VmWriteJsonContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, json: str, path: str) -> VmWriteJsonContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmWriteJsonContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmWriteLineContractFunction(ContractFunction):
    """ContractFunction for the writeLine method."""

    def __call__(self, path: str, data: str) -> VmWriteLineContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(path), dataclass_to_tuple(data)
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class VmWriteTomlContractFunction0(ContractFunction):
    """ContractFunction for the writeToml method."""

    def __call__(self, json: str, path: str, valueKey: str) -> VmWriteTomlContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(json), dataclass_to_tuple(path), dataclass_to_tuple(valueKey))  # type: ignore
        return cast(VmWriteTomlContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmWriteTomlContractFunction1(ContractFunction):
    """ContractFunction for the writeToml method."""

    def __call__(self, json: str, path: str) -> VmWriteTomlContractFunction:  # type: ignore
        super().__call__(dataclass_to_tuple(json), dataclass_to_tuple(path))  # type: ignore
        return cast(VmWriteTomlContractFunction, self)

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: CallOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function
        raw_values = super().call(
            transaction, block_identifier, state_override, ccip_read_enabled
        )


class VmWriteTomlContractFunction(ContractFunction):
    """ContractFunction for the writeToml method."""

    # super() call methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ# disable this warning when there is overloading
    # pylint: disable=function-redefined

    @overload
    def __call__(self, json: str, path: str, valueKey: str) -> VmWriteTomlContractFunction0:  # type: ignore
        ...

    @overload
    def __call__(self, json: str, path: str) -> VmWriteTomlContractFunction1:  # type: ignore
        ...

    def __call__(self, *args) -> VmWriteTomlContractFunction:  # type: ignore
        clone = super().__call__(*(dataclass_to_tuple(arg) for arg in args))
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self  # type: ignore


class VmContractFunctions(ContractFunctions):
    """ContractFunctions for the Vm contract."""

    accesses: VmAccessesContractFunction

    activeFork: VmActiveForkContractFunction

    addr: VmAddrContractFunction

    allowCheatcodes: VmAllowCheatcodesContractFunction

    assertApproxEqAbs: VmAssertApproxEqAbsContractFunction

    assertApproxEqAbsDecimal: VmAssertApproxEqAbsDecimalContractFunction

    assertApproxEqRel: VmAssertApproxEqRelContractFunction

    assertApproxEqRelDecimal: VmAssertApproxEqRelDecimalContractFunction

    assertEq: VmAssertEqContractFunction

    assertEqDecimal: VmAssertEqDecimalContractFunction

    assertFalse: VmAssertFalseContractFunction

    assertGe: VmAssertGeContractFunction

    assertGeDecimal: VmAssertGeDecimalContractFunction

    assertGt: VmAssertGtContractFunction

    assertGtDecimal: VmAssertGtDecimalContractFunction

    assertLe: VmAssertLeContractFunction

    assertLeDecimal: VmAssertLeDecimalContractFunction

    assertLt: VmAssertLtContractFunction

    assertLtDecimal: VmAssertLtDecimalContractFunction

    assertNotEq: VmAssertNotEqContractFunction

    assertNotEqDecimal: VmAssertNotEqDecimalContractFunction

    assertTrue: VmAssertTrueContractFunction

    assume: VmAssumeContractFunction

    breakpoint: VmBreakpointContractFunction

    broadcast: VmBroadcastContractFunction

    chainId: VmChainIdContractFunction

    clearMockedCalls: VmClearMockedCallsContractFunction

    closeFile: VmCloseFileContractFunction

    coinbase: VmCoinbaseContractFunction

    computeCreate2Address: VmComputeCreate2AddressContractFunction

    computeCreateAddress: VmComputeCreateAddressContractFunction

    copyFile: VmCopyFileContractFunction

    createDir: VmCreateDirContractFunction

    createFork: VmCreateForkContractFunction

    createSelectFork: VmCreateSelectForkContractFunction

    createWallet: VmCreateWalletContractFunction

    deal: VmDealContractFunction

    deleteSnapshot: VmDeleteSnapshotContractFunction

    deleteSnapshots: VmDeleteSnapshotsContractFunction

    deriveKey: VmDeriveKeyContractFunction

    difficulty: VmDifficultyContractFunction

    dumpState: VmDumpStateContractFunction

    envAddress: VmEnvAddressContractFunction

    envBool: VmEnvBoolContractFunction

    envBytes: VmEnvBytesContractFunction

    envBytes32: VmEnvBytes32ContractFunction

    envInt: VmEnvIntContractFunction

    envOr: VmEnvOrContractFunction

    envString: VmEnvStringContractFunction

    envUint: VmEnvUintContractFunction

    etch: VmEtchContractFunction

    eth_getLogs: VmEth_getLogsContractFunction

    exists: VmExistsContractFunction

    expectCall: VmExpectCallContractFunction

    expectCallMinGas: VmExpectCallMinGasContractFunction

    expectEmit: VmExpectEmitContractFunction

    expectRevert: VmExpectRevertContractFunction

    expectSafeMemory: VmExpectSafeMemoryContractFunction

    expectSafeMemoryCall: VmExpectSafeMemoryCallContractFunction

    fee: VmFeeContractFunction

    ffi: VmFfiContractFunction

    fsMetadata: VmFsMetadataContractFunction

    getBlockNumber: VmGetBlockNumberContractFunction

    getBlockTimestamp: VmGetBlockTimestampContractFunction

    getCode: VmGetCodeContractFunction

    getDeployedCode: VmGetDeployedCodeContractFunction

    getLabel: VmGetLabelContractFunction

    getMappingKeyAndParentOf: VmGetMappingKeyAndParentOfContractFunction

    getMappingLength: VmGetMappingLengthContractFunction

    getMappingSlotAt: VmGetMappingSlotAtContractFunction

    getNonce: VmGetNonceContractFunction

    getRecordedLogs: VmGetRecordedLogsContractFunction

    isDir: VmIsDirContractFunction

    isFile: VmIsFileContractFunction

    isPersistent: VmIsPersistentContractFunction

    keyExists: VmKeyExistsContractFunction

    keyExistsJson: VmKeyExistsJsonContractFunction

    keyExistsToml: VmKeyExistsTomlContractFunction

    label: VmLabelContractFunction

    load: VmLoadContractFunction

    loadAllocs: VmLoadAllocsContractFunction

    makePersistent: VmMakePersistentContractFunction

    mockCall: VmMockCallContractFunction

    mockCallRevert: VmMockCallRevertContractFunction

    parseAddress: VmParseAddressContractFunction

    parseBool: VmParseBoolContractFunction

    parseBytes: VmParseBytesContractFunction

    parseBytes32: VmParseBytes32ContractFunction

    parseInt: VmParseIntContractFunction

    parseJson: VmParseJsonContractFunction

    parseJsonAddress: VmParseJsonAddressContractFunction

    parseJsonAddressArray: VmParseJsonAddressArrayContractFunction

    parseJsonBool: VmParseJsonBoolContractFunction

    parseJsonBoolArray: VmParseJsonBoolArrayContractFunction

    parseJsonBytes: VmParseJsonBytesContractFunction

    parseJsonBytes32: VmParseJsonBytes32ContractFunction

    parseJsonBytes32Array: VmParseJsonBytes32ArrayContractFunction

    parseJsonBytesArray: VmParseJsonBytesArrayContractFunction

    parseJsonInt: VmParseJsonIntContractFunction

    parseJsonIntArray: VmParseJsonIntArrayContractFunction

    parseJsonKeys: VmParseJsonKeysContractFunction

    parseJsonString: VmParseJsonStringContractFunction

    parseJsonStringArray: VmParseJsonStringArrayContractFunction

    parseJsonUint: VmParseJsonUintContractFunction

    parseJsonUintArray: VmParseJsonUintArrayContractFunction

    parseToml: VmParseTomlContractFunction

    parseTomlAddress: VmParseTomlAddressContractFunction

    parseTomlAddressArray: VmParseTomlAddressArrayContractFunction

    parseTomlBool: VmParseTomlBoolContractFunction

    parseTomlBoolArray: VmParseTomlBoolArrayContractFunction

    parseTomlBytes: VmParseTomlBytesContractFunction

    parseTomlBytes32: VmParseTomlBytes32ContractFunction

    parseTomlBytes32Array: VmParseTomlBytes32ArrayContractFunction

    parseTomlBytesArray: VmParseTomlBytesArrayContractFunction

    parseTomlInt: VmParseTomlIntContractFunction

    parseTomlIntArray: VmParseTomlIntArrayContractFunction

    parseTomlKeys: VmParseTomlKeysContractFunction

    parseTomlString: VmParseTomlStringContractFunction

    parseTomlStringArray: VmParseTomlStringArrayContractFunction

    parseTomlUint: VmParseTomlUintContractFunction

    parseTomlUintArray: VmParseTomlUintArrayContractFunction

    parseUint: VmParseUintContractFunction

    pauseGasMetering: VmPauseGasMeteringContractFunction

    prank: VmPrankContractFunction

    prevrandao: VmPrevrandaoContractFunction

    projectRoot: VmProjectRootContractFunction

    readCallers: VmReadCallersContractFunction

    readDir: VmReadDirContractFunction

    readFile: VmReadFileContractFunction

    readFileBinary: VmReadFileBinaryContractFunction

    readLine: VmReadLineContractFunction

    readLink: VmReadLinkContractFunction

    record: VmRecordContractFunction

    recordLogs: VmRecordLogsContractFunction

    rememberKey: VmRememberKeyContractFunction

    removeDir: VmRemoveDirContractFunction

    removeFile: VmRemoveFileContractFunction

    replace: VmReplaceContractFunction

    resetNonce: VmResetNonceContractFunction

    resumeGasMetering: VmResumeGasMeteringContractFunction

    revertTo: VmRevertToContractFunction

    revertToAndDelete: VmRevertToAndDeleteContractFunction

    revokePersistent: VmRevokePersistentContractFunction

    roll: VmRollContractFunction

    rollFork: VmRollForkContractFunction

    rpc: VmRpcContractFunction

    rpcUrl: VmRpcUrlContractFunction

    rpcUrlStructs: VmRpcUrlStructsContractFunction

    rpcUrls: VmRpcUrlsContractFunction

    selectFork: VmSelectForkContractFunction

    serializeAddress: VmSerializeAddressContractFunction

    serializeBool: VmSerializeBoolContractFunction

    serializeBytes: VmSerializeBytesContractFunction

    serializeBytes32: VmSerializeBytes32ContractFunction

    serializeInt: VmSerializeIntContractFunction

    serializeJson: VmSerializeJsonContractFunction

    serializeString: VmSerializeStringContractFunction

    serializeUint: VmSerializeUintContractFunction

    setEnv: VmSetEnvContractFunction

    setNonce: VmSetNonceContractFunction

    setNonceUnsafe: VmSetNonceUnsafeContractFunction

    sign: VmSignContractFunction

    signP256: VmSignP256ContractFunction

    skip: VmSkipContractFunction

    sleep: VmSleepContractFunction

    snapshot: VmSnapshotContractFunction

    split: VmSplitContractFunction

    startBroadcast: VmStartBroadcastContractFunction

    startMappingRecording: VmStartMappingRecordingContractFunction

    startPrank: VmStartPrankContractFunction

    startStateDiffRecording: VmStartStateDiffRecordingContractFunction

    stopAndReturnStateDiff: VmStopAndReturnStateDiffContractFunction

    stopBroadcast: VmStopBroadcastContractFunction

    stopExpectSafeMemory: VmStopExpectSafeMemoryContractFunction

    stopMappingRecording: VmStopMappingRecordingContractFunction

    stopPrank: VmStopPrankContractFunction

    store: VmStoreContractFunction

    toBase64: VmToBase64ContractFunction

    toBase64URL: VmToBase64URLContractFunction

    toLowercase: VmToLowercaseContractFunction

    toString: VmToStringContractFunction

    toUppercase: VmToUppercaseContractFunction

    transact: VmTransactContractFunction

    trim: VmTrimContractFunction

    tryFfi: VmTryFfiContractFunction

    txGasPrice: VmTxGasPriceContractFunction

    unixTime: VmUnixTimeContractFunction

    warp: VmWarpContractFunction

    writeFile: VmWriteFileContractFunction

    writeFileBinary: VmWriteFileBinaryContractFunction

    writeJson: VmWriteJsonContractFunction

    writeLine: VmWriteLineContractFunction

    writeToml: VmWriteTomlContractFunction

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)
        self.accesses = VmAccessesContractFunction.factory(
            "accesses",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="accesses",
        )
        self.activeFork = VmActiveForkContractFunction.factory(
            "activeFork",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="activeFork",
        )
        self.addr = VmAddrContractFunction.factory(
            "addr",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="addr",
        )
        self.allowCheatcodes = VmAllowCheatcodesContractFunction.factory(
            "allowCheatcodes",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="allowCheatcodes",
        )
        self.assertApproxEqAbs = VmAssertApproxEqAbsContractFunction.factory(
            "assertApproxEqAbs",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertApproxEqAbs",
        )
        self.assertApproxEqAbsDecimal = (
            VmAssertApproxEqAbsDecimalContractFunction.factory(
                "assertApproxEqAbsDecimal",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="assertApproxEqAbsDecimal",
            )
        )
        self.assertApproxEqRel = VmAssertApproxEqRelContractFunction.factory(
            "assertApproxEqRel",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertApproxEqRel",
        )
        self.assertApproxEqRelDecimal = (
            VmAssertApproxEqRelDecimalContractFunction.factory(
                "assertApproxEqRelDecimal",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="assertApproxEqRelDecimal",
            )
        )
        self.assertEq = VmAssertEqContractFunction.factory(
            "assertEq",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertEq",
        )
        self.assertEqDecimal = VmAssertEqDecimalContractFunction.factory(
            "assertEqDecimal",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertEqDecimal",
        )
        self.assertFalse = VmAssertFalseContractFunction.factory(
            "assertFalse",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertFalse",
        )
        self.assertGe = VmAssertGeContractFunction.factory(
            "assertGe",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertGe",
        )
        self.assertGeDecimal = VmAssertGeDecimalContractFunction.factory(
            "assertGeDecimal",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertGeDecimal",
        )
        self.assertGt = VmAssertGtContractFunction.factory(
            "assertGt",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertGt",
        )
        self.assertGtDecimal = VmAssertGtDecimalContractFunction.factory(
            "assertGtDecimal",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertGtDecimal",
        )
        self.assertLe = VmAssertLeContractFunction.factory(
            "assertLe",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertLe",
        )
        self.assertLeDecimal = VmAssertLeDecimalContractFunction.factory(
            "assertLeDecimal",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertLeDecimal",
        )
        self.assertLt = VmAssertLtContractFunction.factory(
            "assertLt",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertLt",
        )
        self.assertLtDecimal = VmAssertLtDecimalContractFunction.factory(
            "assertLtDecimal",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertLtDecimal",
        )
        self.assertNotEq = VmAssertNotEqContractFunction.factory(
            "assertNotEq",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertNotEq",
        )
        self.assertNotEqDecimal = VmAssertNotEqDecimalContractFunction.factory(
            "assertNotEqDecimal",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertNotEqDecimal",
        )
        self.assertTrue = VmAssertTrueContractFunction.factory(
            "assertTrue",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assertTrue",
        )
        self.assume = VmAssumeContractFunction.factory(
            "assume",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="assume",
        )
        self.breakpoint = VmBreakpointContractFunction.factory(
            "breakpoint",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="breakpoint",
        )
        self.broadcast = VmBroadcastContractFunction.factory(
            "broadcast",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="broadcast",
        )
        self.chainId = VmChainIdContractFunction.factory(
            "chainId",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="chainId",
        )
        self.clearMockedCalls = VmClearMockedCallsContractFunction.factory(
            "clearMockedCalls",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="clearMockedCalls",
        )
        self.closeFile = VmCloseFileContractFunction.factory(
            "closeFile",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="closeFile",
        )
        self.coinbase = VmCoinbaseContractFunction.factory(
            "coinbase",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="coinbase",
        )
        self.computeCreate2Address = (
            VmComputeCreate2AddressContractFunction.factory(
                "computeCreate2Address",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="computeCreate2Address",
            )
        )
        self.computeCreateAddress = (
            VmComputeCreateAddressContractFunction.factory(
                "computeCreateAddress",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="computeCreateAddress",
            )
        )
        self.copyFile = VmCopyFileContractFunction.factory(
            "copyFile",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="copyFile",
        )
        self.createDir = VmCreateDirContractFunction.factory(
            "createDir",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="createDir",
        )
        self.createFork = VmCreateForkContractFunction.factory(
            "createFork",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="createFork",
        )
        self.createSelectFork = VmCreateSelectForkContractFunction.factory(
            "createSelectFork",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="createSelectFork",
        )
        self.createWallet = VmCreateWalletContractFunction.factory(
            "createWallet",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="createWallet",
        )
        self.deal = VmDealContractFunction.factory(
            "deal",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="deal",
        )
        self.deleteSnapshot = VmDeleteSnapshotContractFunction.factory(
            "deleteSnapshot",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="deleteSnapshot",
        )
        self.deleteSnapshots = VmDeleteSnapshotsContractFunction.factory(
            "deleteSnapshots",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="deleteSnapshots",
        )
        self.deriveKey = VmDeriveKeyContractFunction.factory(
            "deriveKey",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="deriveKey",
        )
        self.difficulty = VmDifficultyContractFunction.factory(
            "difficulty",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="difficulty",
        )
        self.dumpState = VmDumpStateContractFunction.factory(
            "dumpState",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="dumpState",
        )
        self.envAddress = VmEnvAddressContractFunction.factory(
            "envAddress",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="envAddress",
        )
        self.envBool = VmEnvBoolContractFunction.factory(
            "envBool",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="envBool",
        )
        self.envBytes = VmEnvBytesContractFunction.factory(
            "envBytes",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="envBytes",
        )
        self.envBytes32 = VmEnvBytes32ContractFunction.factory(
            "envBytes32",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="envBytes32",
        )
        self.envInt = VmEnvIntContractFunction.factory(
            "envInt",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="envInt",
        )
        self.envOr = VmEnvOrContractFunction.factory(
            "envOr",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="envOr",
        )
        self.envString = VmEnvStringContractFunction.factory(
            "envString",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="envString",
        )
        self.envUint = VmEnvUintContractFunction.factory(
            "envUint",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="envUint",
        )
        self.etch = VmEtchContractFunction.factory(
            "etch",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="etch",
        )
        self.eth_getLogs = VmEth_getLogsContractFunction.factory(
            "eth_getLogs",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="eth_getLogs",
        )
        self.exists = VmExistsContractFunction.factory(
            "exists",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="exists",
        )
        self.expectCall = VmExpectCallContractFunction.factory(
            "expectCall",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="expectCall",
        )
        self.expectCallMinGas = VmExpectCallMinGasContractFunction.factory(
            "expectCallMinGas",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="expectCallMinGas",
        )
        self.expectEmit = VmExpectEmitContractFunction.factory(
            "expectEmit",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="expectEmit",
        )
        self.expectRevert = VmExpectRevertContractFunction.factory(
            "expectRevert",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="expectRevert",
        )
        self.expectSafeMemory = VmExpectSafeMemoryContractFunction.factory(
            "expectSafeMemory",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="expectSafeMemory",
        )
        self.expectSafeMemoryCall = (
            VmExpectSafeMemoryCallContractFunction.factory(
                "expectSafeMemoryCall",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="expectSafeMemoryCall",
            )
        )
        self.fee = VmFeeContractFunction.factory(
            "fee",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="fee",
        )
        self.ffi = VmFfiContractFunction.factory(
            "ffi",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="ffi",
        )
        self.fsMetadata = VmFsMetadataContractFunction.factory(
            "fsMetadata",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="fsMetadata",
        )
        self.getBlockNumber = VmGetBlockNumberContractFunction.factory(
            "getBlockNumber",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getBlockNumber",
        )
        self.getBlockTimestamp = VmGetBlockTimestampContractFunction.factory(
            "getBlockTimestamp",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getBlockTimestamp",
        )
        self.getCode = VmGetCodeContractFunction.factory(
            "getCode",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getCode",
        )
        self.getDeployedCode = VmGetDeployedCodeContractFunction.factory(
            "getDeployedCode",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getDeployedCode",
        )
        self.getLabel = VmGetLabelContractFunction.factory(
            "getLabel",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getLabel",
        )
        self.getMappingKeyAndParentOf = (
            VmGetMappingKeyAndParentOfContractFunction.factory(
                "getMappingKeyAndParentOf",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="getMappingKeyAndParentOf",
            )
        )
        self.getMappingLength = VmGetMappingLengthContractFunction.factory(
            "getMappingLength",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getMappingLength",
        )
        self.getMappingSlotAt = VmGetMappingSlotAtContractFunction.factory(
            "getMappingSlotAt",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getMappingSlotAt",
        )
        self.getNonce = VmGetNonceContractFunction.factory(
            "getNonce",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getNonce",
        )
        self.getRecordedLogs = VmGetRecordedLogsContractFunction.factory(
            "getRecordedLogs",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="getRecordedLogs",
        )
        self.isDir = VmIsDirContractFunction.factory(
            "isDir",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="isDir",
        )
        self.isFile = VmIsFileContractFunction.factory(
            "isFile",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="isFile",
        )
        self.isPersistent = VmIsPersistentContractFunction.factory(
            "isPersistent",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="isPersistent",
        )
        self.keyExists = VmKeyExistsContractFunction.factory(
            "keyExists",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="keyExists",
        )
        self.keyExistsJson = VmKeyExistsJsonContractFunction.factory(
            "keyExistsJson",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="keyExistsJson",
        )
        self.keyExistsToml = VmKeyExistsTomlContractFunction.factory(
            "keyExistsToml",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="keyExistsToml",
        )
        self.label = VmLabelContractFunction.factory(
            "label",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="label",
        )
        self.load = VmLoadContractFunction.factory(
            "load",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="load",
        )
        self.loadAllocs = VmLoadAllocsContractFunction.factory(
            "loadAllocs",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="loadAllocs",
        )
        self.makePersistent = VmMakePersistentContractFunction.factory(
            "makePersistent",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="makePersistent",
        )
        self.mockCall = VmMockCallContractFunction.factory(
            "mockCall",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="mockCall",
        )
        self.mockCallRevert = VmMockCallRevertContractFunction.factory(
            "mockCallRevert",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="mockCallRevert",
        )
        self.parseAddress = VmParseAddressContractFunction.factory(
            "parseAddress",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseAddress",
        )
        self.parseBool = VmParseBoolContractFunction.factory(
            "parseBool",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseBool",
        )
        self.parseBytes = VmParseBytesContractFunction.factory(
            "parseBytes",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseBytes",
        )
        self.parseBytes32 = VmParseBytes32ContractFunction.factory(
            "parseBytes32",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseBytes32",
        )
        self.parseInt = VmParseIntContractFunction.factory(
            "parseInt",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseInt",
        )
        self.parseJson = VmParseJsonContractFunction.factory(
            "parseJson",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJson",
        )
        self.parseJsonAddress = VmParseJsonAddressContractFunction.factory(
            "parseJsonAddress",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonAddress",
        )
        self.parseJsonAddressArray = (
            VmParseJsonAddressArrayContractFunction.factory(
                "parseJsonAddressArray",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="parseJsonAddressArray",
            )
        )
        self.parseJsonBool = VmParseJsonBoolContractFunction.factory(
            "parseJsonBool",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonBool",
        )
        self.parseJsonBoolArray = VmParseJsonBoolArrayContractFunction.factory(
            "parseJsonBoolArray",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonBoolArray",
        )
        self.parseJsonBytes = VmParseJsonBytesContractFunction.factory(
            "parseJsonBytes",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonBytes",
        )
        self.parseJsonBytes32 = VmParseJsonBytes32ContractFunction.factory(
            "parseJsonBytes32",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonBytes32",
        )
        self.parseJsonBytes32Array = (
            VmParseJsonBytes32ArrayContractFunction.factory(
                "parseJsonBytes32Array",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="parseJsonBytes32Array",
            )
        )
        self.parseJsonBytesArray = (
            VmParseJsonBytesArrayContractFunction.factory(
                "parseJsonBytesArray",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="parseJsonBytesArray",
            )
        )
        self.parseJsonInt = VmParseJsonIntContractFunction.factory(
            "parseJsonInt",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonInt",
        )
        self.parseJsonIntArray = VmParseJsonIntArrayContractFunction.factory(
            "parseJsonIntArray",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonIntArray",
        )
        self.parseJsonKeys = VmParseJsonKeysContractFunction.factory(
            "parseJsonKeys",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonKeys",
        )
        self.parseJsonString = VmParseJsonStringContractFunction.factory(
            "parseJsonString",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonString",
        )
        self.parseJsonStringArray = (
            VmParseJsonStringArrayContractFunction.factory(
                "parseJsonStringArray",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="parseJsonStringArray",
            )
        )
        self.parseJsonUint = VmParseJsonUintContractFunction.factory(
            "parseJsonUint",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonUint",
        )
        self.parseJsonUintArray = VmParseJsonUintArrayContractFunction.factory(
            "parseJsonUintArray",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseJsonUintArray",
        )
        self.parseToml = VmParseTomlContractFunction.factory(
            "parseToml",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseToml",
        )
        self.parseTomlAddress = VmParseTomlAddressContractFunction.factory(
            "parseTomlAddress",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlAddress",
        )
        self.parseTomlAddressArray = (
            VmParseTomlAddressArrayContractFunction.factory(
                "parseTomlAddressArray",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="parseTomlAddressArray",
            )
        )
        self.parseTomlBool = VmParseTomlBoolContractFunction.factory(
            "parseTomlBool",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlBool",
        )
        self.parseTomlBoolArray = VmParseTomlBoolArrayContractFunction.factory(
            "parseTomlBoolArray",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlBoolArray",
        )
        self.parseTomlBytes = VmParseTomlBytesContractFunction.factory(
            "parseTomlBytes",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlBytes",
        )
        self.parseTomlBytes32 = VmParseTomlBytes32ContractFunction.factory(
            "parseTomlBytes32",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlBytes32",
        )
        self.parseTomlBytes32Array = (
            VmParseTomlBytes32ArrayContractFunction.factory(
                "parseTomlBytes32Array",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="parseTomlBytes32Array",
            )
        )
        self.parseTomlBytesArray = (
            VmParseTomlBytesArrayContractFunction.factory(
                "parseTomlBytesArray",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="parseTomlBytesArray",
            )
        )
        self.parseTomlInt = VmParseTomlIntContractFunction.factory(
            "parseTomlInt",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlInt",
        )
        self.parseTomlIntArray = VmParseTomlIntArrayContractFunction.factory(
            "parseTomlIntArray",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlIntArray",
        )
        self.parseTomlKeys = VmParseTomlKeysContractFunction.factory(
            "parseTomlKeys",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlKeys",
        )
        self.parseTomlString = VmParseTomlStringContractFunction.factory(
            "parseTomlString",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlString",
        )
        self.parseTomlStringArray = (
            VmParseTomlStringArrayContractFunction.factory(
                "parseTomlStringArray",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="parseTomlStringArray",
            )
        )
        self.parseTomlUint = VmParseTomlUintContractFunction.factory(
            "parseTomlUint",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlUint",
        )
        self.parseTomlUintArray = VmParseTomlUintArrayContractFunction.factory(
            "parseTomlUintArray",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseTomlUintArray",
        )
        self.parseUint = VmParseUintContractFunction.factory(
            "parseUint",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="parseUint",
        )
        self.pauseGasMetering = VmPauseGasMeteringContractFunction.factory(
            "pauseGasMetering",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="pauseGasMetering",
        )
        self.prank = VmPrankContractFunction.factory(
            "prank",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="prank",
        )
        self.prevrandao = VmPrevrandaoContractFunction.factory(
            "prevrandao",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="prevrandao",
        )
        self.projectRoot = VmProjectRootContractFunction.factory(
            "projectRoot",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="projectRoot",
        )
        self.readCallers = VmReadCallersContractFunction.factory(
            "readCallers",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="readCallers",
        )
        self.readDir = VmReadDirContractFunction.factory(
            "readDir",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="readDir",
        )
        self.readFile = VmReadFileContractFunction.factory(
            "readFile",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="readFile",
        )
        self.readFileBinary = VmReadFileBinaryContractFunction.factory(
            "readFileBinary",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="readFileBinary",
        )
        self.readLine = VmReadLineContractFunction.factory(
            "readLine",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="readLine",
        )
        self.readLink = VmReadLinkContractFunction.factory(
            "readLink",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="readLink",
        )
        self.record = VmRecordContractFunction.factory(
            "record",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="record",
        )
        self.recordLogs = VmRecordLogsContractFunction.factory(
            "recordLogs",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="recordLogs",
        )
        self.rememberKey = VmRememberKeyContractFunction.factory(
            "rememberKey",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="rememberKey",
        )
        self.removeDir = VmRemoveDirContractFunction.factory(
            "removeDir",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="removeDir",
        )
        self.removeFile = VmRemoveFileContractFunction.factory(
            "removeFile",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="removeFile",
        )
        self.replace = VmReplaceContractFunction.factory(
            "replace",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="replace",
        )
        self.resetNonce = VmResetNonceContractFunction.factory(
            "resetNonce",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="resetNonce",
        )
        self.resumeGasMetering = VmResumeGasMeteringContractFunction.factory(
            "resumeGasMetering",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="resumeGasMetering",
        )
        self.revertTo = VmRevertToContractFunction.factory(
            "revertTo",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="revertTo",
        )
        self.revertToAndDelete = VmRevertToAndDeleteContractFunction.factory(
            "revertToAndDelete",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="revertToAndDelete",
        )
        self.revokePersistent = VmRevokePersistentContractFunction.factory(
            "revokePersistent",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="revokePersistent",
        )
        self.roll = VmRollContractFunction.factory(
            "roll",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="roll",
        )
        self.rollFork = VmRollForkContractFunction.factory(
            "rollFork",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="rollFork",
        )
        self.rpc = VmRpcContractFunction.factory(
            "rpc",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="rpc",
        )
        self.rpcUrl = VmRpcUrlContractFunction.factory(
            "rpcUrl",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="rpcUrl",
        )
        self.rpcUrlStructs = VmRpcUrlStructsContractFunction.factory(
            "rpcUrlStructs",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="rpcUrlStructs",
        )
        self.rpcUrls = VmRpcUrlsContractFunction.factory(
            "rpcUrls",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="rpcUrls",
        )
        self.selectFork = VmSelectForkContractFunction.factory(
            "selectFork",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="selectFork",
        )
        self.serializeAddress = VmSerializeAddressContractFunction.factory(
            "serializeAddress",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="serializeAddress",
        )
        self.serializeBool = VmSerializeBoolContractFunction.factory(
            "serializeBool",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="serializeBool",
        )
        self.serializeBytes = VmSerializeBytesContractFunction.factory(
            "serializeBytes",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="serializeBytes",
        )
        self.serializeBytes32 = VmSerializeBytes32ContractFunction.factory(
            "serializeBytes32",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="serializeBytes32",
        )
        self.serializeInt = VmSerializeIntContractFunction.factory(
            "serializeInt",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="serializeInt",
        )
        self.serializeJson = VmSerializeJsonContractFunction.factory(
            "serializeJson",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="serializeJson",
        )
        self.serializeString = VmSerializeStringContractFunction.factory(
            "serializeString",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="serializeString",
        )
        self.serializeUint = VmSerializeUintContractFunction.factory(
            "serializeUint",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="serializeUint",
        )
        self.setEnv = VmSetEnvContractFunction.factory(
            "setEnv",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="setEnv",
        )
        self.setNonce = VmSetNonceContractFunction.factory(
            "setNonce",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="setNonce",
        )
        self.setNonceUnsafe = VmSetNonceUnsafeContractFunction.factory(
            "setNonceUnsafe",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="setNonceUnsafe",
        )
        self.sign = VmSignContractFunction.factory(
            "sign",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="sign",
        )
        self.signP256 = VmSignP256ContractFunction.factory(
            "signP256",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="signP256",
        )
        self.skip = VmSkipContractFunction.factory(
            "skip",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="skip",
        )
        self.sleep = VmSleepContractFunction.factory(
            "sleep",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="sleep",
        )
        self.snapshot = VmSnapshotContractFunction.factory(
            "snapshot",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="snapshot",
        )
        self.split = VmSplitContractFunction.factory(
            "split",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="split",
        )
        self.startBroadcast = VmStartBroadcastContractFunction.factory(
            "startBroadcast",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="startBroadcast",
        )
        self.startMappingRecording = (
            VmStartMappingRecordingContractFunction.factory(
                "startMappingRecording",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="startMappingRecording",
            )
        )
        self.startPrank = VmStartPrankContractFunction.factory(
            "startPrank",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="startPrank",
        )
        self.startStateDiffRecording = (
            VmStartStateDiffRecordingContractFunction.factory(
                "startStateDiffRecording",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="startStateDiffRecording",
            )
        )
        self.stopAndReturnStateDiff = (
            VmStopAndReturnStateDiffContractFunction.factory(
                "stopAndReturnStateDiff",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="stopAndReturnStateDiff",
            )
        )
        self.stopBroadcast = VmStopBroadcastContractFunction.factory(
            "stopBroadcast",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="stopBroadcast",
        )
        self.stopExpectSafeMemory = (
            VmStopExpectSafeMemoryContractFunction.factory(
                "stopExpectSafeMemory",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="stopExpectSafeMemory",
            )
        )
        self.stopMappingRecording = (
            VmStopMappingRecordingContractFunction.factory(
                "stopMappingRecording",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                function_identifier="stopMappingRecording",
            )
        )
        self.stopPrank = VmStopPrankContractFunction.factory(
            "stopPrank",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="stopPrank",
        )
        self.store = VmStoreContractFunction.factory(
            "store",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="store",
        )
        self.toBase64 = VmToBase64ContractFunction.factory(
            "toBase64",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="toBase64",
        )
        self.toBase64URL = VmToBase64URLContractFunction.factory(
            "toBase64URL",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="toBase64URL",
        )
        self.toLowercase = VmToLowercaseContractFunction.factory(
            "toLowercase",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="toLowercase",
        )
        self.toString = VmToStringContractFunction.factory(
            "toString",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="toString",
        )
        self.toUppercase = VmToUppercaseContractFunction.factory(
            "toUppercase",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="toUppercase",
        )
        self.transact = VmTransactContractFunction.factory(
            "transact",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="transact",
        )
        self.trim = VmTrimContractFunction.factory(
            "trim",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="trim",
        )
        self.tryFfi = VmTryFfiContractFunction.factory(
            "tryFfi",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="tryFfi",
        )
        self.txGasPrice = VmTxGasPriceContractFunction.factory(
            "txGasPrice",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="txGasPrice",
        )
        self.unixTime = VmUnixTimeContractFunction.factory(
            "unixTime",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="unixTime",
        )
        self.warp = VmWarpContractFunction.factory(
            "warp",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="warp",
        )
        self.writeFile = VmWriteFileContractFunction.factory(
            "writeFile",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="writeFile",
        )
        self.writeFileBinary = VmWriteFileBinaryContractFunction.factory(
            "writeFileBinary",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="writeFileBinary",
        )
        self.writeJson = VmWriteJsonContractFunction.factory(
            "writeJson",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="writeJson",
        )
        self.writeLine = VmWriteLineContractFunction.factory(
            "writeLine",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="writeLine",
        )
        self.writeToml = VmWriteTomlContractFunction.factory(
            "writeToml",
            w3=w3,
            contract_abi=abi,
            address=address,
            decode_tuples=decode_tuples,
            function_identifier="writeToml",
        )


vm_abi: ABI = cast(
    ABI,
    [
        {
            "type": "function",
            "name": "accesses",
            "inputs": [
                {"name": "target", "type": "address", "internalType": "address"}
            ],
            "outputs": [
                {
                    "name": "readSlots",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
                {
                    "name": "writeSlots",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "activeFork",
            "inputs": [],
            "outputs": [
                {"name": "forkId", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "addr",
            "inputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [
                {
                    "name": "keyAddr",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "allowCheatcodes",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "assertApproxEqAbs",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "maxDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqAbs",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "maxDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqAbs",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "maxDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqAbs",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "maxDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqAbsDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "maxDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqAbsDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "maxDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqAbsDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "maxDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqAbsDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "maxDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqRel",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "maxPercentDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqRel",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "maxPercentDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqRel",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "maxPercentDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqRel",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "maxPercentDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqRelDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "maxPercentDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqRelDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "maxPercentDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqRelDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "maxPercentDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertApproxEqRelDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "maxPercentDelta",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
                {
                    "name": "right",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
                {
                    "name": "right",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "address", "internalType": "address"},
                {"name": "right", "type": "address", "internalType": "address"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "string", "internalType": "string"},
                {"name": "right", "type": "string", "internalType": "string"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "address[]",
                    "internalType": "address[]",
                },
                {
                    "name": "right",
                    "type": "address[]",
                    "internalType": "address[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "address[]",
                    "internalType": "address[]",
                },
                {
                    "name": "right",
                    "type": "address[]",
                    "internalType": "address[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bool", "internalType": "bool"},
                {"name": "right", "type": "bool", "internalType": "bool"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "address", "internalType": "address"},
                {"name": "right", "type": "address", "internalType": "address"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
                {
                    "name": "right",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bool[]", "internalType": "bool[]"},
                {"name": "right", "type": "bool[]", "internalType": "bool[]"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
                {
                    "name": "right",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bytes32", "internalType": "bytes32"},
                {"name": "right", "type": "bytes32", "internalType": "bytes32"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
                {
                    "name": "right",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bytes", "internalType": "bytes"},
                {"name": "right", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bytes32", "internalType": "bytes32"},
                {"name": "right", "type": "bytes32", "internalType": "bytes32"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "string[]",
                    "internalType": "string[]",
                },
                {
                    "name": "right",
                    "type": "string[]",
                    "internalType": "string[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
                {
                    "name": "right",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bytes", "internalType": "bytes"},
                {"name": "right", "type": "bytes", "internalType": "bytes"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bool[]", "internalType": "bool[]"},
                {"name": "right", "type": "bool[]", "internalType": "bool[]"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bytes[]", "internalType": "bytes[]"},
                {"name": "right", "type": "bytes[]", "internalType": "bytes[]"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "string[]",
                    "internalType": "string[]",
                },
                {
                    "name": "right",
                    "type": "string[]",
                    "internalType": "string[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "string", "internalType": "string"},
                {"name": "right", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bytes[]", "internalType": "bytes[]"},
                {"name": "right", "type": "bytes[]", "internalType": "bytes[]"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "bool", "internalType": "bool"},
                {"name": "right", "type": "bool", "internalType": "bool"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEq",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEqDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEqDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEqDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertEqDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertFalse",
            "inputs": [
                {"name": "condition", "type": "bool", "internalType": "bool"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertFalse",
            "inputs": [
                {"name": "condition", "type": "bool", "internalType": "bool"}
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGe",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGe",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGe",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGe",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGeDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGeDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGeDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGeDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGt",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGt",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGt",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGt",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGtDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGtDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGtDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertGtDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLe",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLe",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLe",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLe",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLeDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLeDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLeDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLeDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLt",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLt",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLt",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLt",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLtDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLtDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLtDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertLtDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
                {
                    "name": "right",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
                {
                    "name": "right",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bool", "internalType": "bool"},
                {"name": "right", "type": "bool", "internalType": "bool"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bytes[]", "internalType": "bytes[]"},
                {"name": "right", "type": "bytes[]", "internalType": "bytes[]"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bool", "internalType": "bool"},
                {"name": "right", "type": "bool", "internalType": "bool"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bool[]", "internalType": "bool[]"},
                {"name": "right", "type": "bool[]", "internalType": "bool[]"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bytes", "internalType": "bytes"},
                {"name": "right", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "address[]",
                    "internalType": "address[]",
                },
                {
                    "name": "right",
                    "type": "address[]",
                    "internalType": "address[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
                {
                    "name": "right",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bool[]", "internalType": "bool[]"},
                {"name": "right", "type": "bool[]", "internalType": "bool[]"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "string", "internalType": "string"},
                {"name": "right", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "address[]",
                    "internalType": "address[]",
                },
                {
                    "name": "right",
                    "type": "address[]",
                    "internalType": "address[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "string", "internalType": "string"},
                {"name": "right", "type": "string", "internalType": "string"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "address", "internalType": "address"},
                {"name": "right", "type": "address", "internalType": "address"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bytes32", "internalType": "bytes32"},
                {"name": "right", "type": "bytes32", "internalType": "bytes32"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bytes", "internalType": "bytes"},
                {"name": "right", "type": "bytes", "internalType": "bytes"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
                {
                    "name": "right",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "address", "internalType": "address"},
                {"name": "right", "type": "address", "internalType": "address"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bytes32", "internalType": "bytes32"},
                {"name": "right", "type": "bytes32", "internalType": "bytes32"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "string[]",
                    "internalType": "string[]",
                },
                {
                    "name": "right",
                    "type": "string[]",
                    "internalType": "string[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
                {
                    "name": "right",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "string[]",
                    "internalType": "string[]",
                },
                {
                    "name": "right",
                    "type": "string[]",
                    "internalType": "string[]",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {
                    "name": "left",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
                {
                    "name": "right",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "bytes[]", "internalType": "bytes[]"},
                {"name": "right", "type": "bytes[]", "internalType": "bytes[]"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEq",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEqDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEqDecimal",
            "inputs": [
                {"name": "left", "type": "int256", "internalType": "int256"},
                {"name": "right", "type": "int256", "internalType": "int256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEqDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertNotEqDecimal",
            "inputs": [
                {"name": "left", "type": "uint256", "internalType": "uint256"},
                {"name": "right", "type": "uint256", "internalType": "uint256"},
                {
                    "name": "decimals",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertTrue",
            "inputs": [
                {"name": "condition", "type": "bool", "internalType": "bool"}
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assertTrue",
            "inputs": [
                {"name": "condition", "type": "bool", "internalType": "bool"},
                {"name": "error", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "assume",
            "inputs": [
                {"name": "condition", "type": "bool", "internalType": "bool"}
            ],
            "outputs": [],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "breakpoint",
            "inputs": [
                {"name": "char", "type": "string", "internalType": "string"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "breakpoint",
            "inputs": [
                {"name": "char", "type": "string", "internalType": "string"},
                {"name": "value", "type": "bool", "internalType": "bool"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "broadcast",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "broadcast",
            "inputs": [
                {"name": "signer", "type": "address", "internalType": "address"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "broadcast",
            "inputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "chainId",
            "inputs": [
                {
                    "name": "newChainId",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "clearMockedCalls",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "closeFile",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "coinbase",
            "inputs": [
                {
                    "name": "newCoinbase",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "computeCreate2Address",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {
                    "name": "initCodeHash",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {"name": "", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "computeCreate2Address",
            "inputs": [
                {"name": "salt", "type": "bytes32", "internalType": "bytes32"},
                {
                    "name": "initCodeHash",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
                {
                    "name": "deployer",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [
                {"name": "", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "computeCreateAddress",
            "inputs": [
                {
                    "name": "deployer",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "nonce", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [
                {"name": "", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "copyFile",
            "inputs": [
                {"name": "from", "type": "string", "internalType": "string"},
                {"name": "to", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "copied", "type": "uint64", "internalType": "uint64"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createDir",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"},
                {"name": "recursive", "type": "bool", "internalType": "bool"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createFork",
            "inputs": [
                {
                    "name": "urlOrAlias",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {"name": "forkId", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createFork",
            "inputs": [
                {
                    "name": "urlOrAlias",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "blockNumber",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [
                {"name": "forkId", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createFork",
            "inputs": [
                {
                    "name": "urlOrAlias",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "txHash",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {"name": "forkId", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createSelectFork",
            "inputs": [
                {
                    "name": "urlOrAlias",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "blockNumber",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [
                {"name": "forkId", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createSelectFork",
            "inputs": [
                {
                    "name": "urlOrAlias",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "txHash",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {"name": "forkId", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createSelectFork",
            "inputs": [
                {
                    "name": "urlOrAlias",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {"name": "forkId", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createWallet",
            "inputs": [
                {
                    "name": "walletLabel",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {
                    "name": "wallet",
                    "type": "tuple",
                    "internalType": "struct VmSafe.Wallet",
                    "components": [
                        {
                            "name": "addr",
                            "type": "address",
                            "internalType": "address",
                        },
                        {
                            "name": "publicKeyX",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "publicKeyY",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "privateKey",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createWallet",
            "inputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [
                {
                    "name": "wallet",
                    "type": "tuple",
                    "internalType": "struct VmSafe.Wallet",
                    "components": [
                        {
                            "name": "addr",
                            "type": "address",
                            "internalType": "address",
                        },
                        {
                            "name": "publicKeyX",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "publicKeyY",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "privateKey",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "createWallet",
            "inputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "walletLabel",
                    "type": "string",
                    "internalType": "string",
                },
            ],
            "outputs": [
                {
                    "name": "wallet",
                    "type": "tuple",
                    "internalType": "struct VmSafe.Wallet",
                    "components": [
                        {
                            "name": "addr",
                            "type": "address",
                            "internalType": "address",
                        },
                        {
                            "name": "publicKeyX",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "publicKeyY",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "privateKey",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "deal",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "newBalance",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "deleteSnapshot",
            "inputs": [
                {
                    "name": "snapshotId",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [
                {"name": "success", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "deleteSnapshots",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "deriveKey",
            "inputs": [
                {
                    "name": "mnemonic",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "derivationPath",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "index", "type": "uint32", "internalType": "uint32"},
                {
                    "name": "language",
                    "type": "string",
                    "internalType": "string",
                },
            ],
            "outputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "deriveKey",
            "inputs": [
                {
                    "name": "mnemonic",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "index", "type": "uint32", "internalType": "uint32"},
                {
                    "name": "language",
                    "type": "string",
                    "internalType": "string",
                },
            ],
            "outputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "deriveKey",
            "inputs": [
                {
                    "name": "mnemonic",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "index", "type": "uint32", "internalType": "uint32"},
            ],
            "outputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "deriveKey",
            "inputs": [
                {
                    "name": "mnemonic",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "derivationPath",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "index", "type": "uint32", "internalType": "uint32"},
            ],
            "outputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "difficulty",
            "inputs": [
                {
                    "name": "newDifficulty",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "dumpState",
            "inputs": [
                {
                    "name": "pathToStateJson",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "envAddress",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "value", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envAddress",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "address[]",
                    "internalType": "address[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envBool",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "value", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envBool",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "value", "type": "bool[]", "internalType": "bool[]"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envBytes",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "value", "type": "bytes", "internalType": "bytes"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envBytes",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "value", "type": "bytes[]", "internalType": "bytes[]"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envBytes32",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envBytes32",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "value", "type": "bytes32", "internalType": "bytes32"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envInt",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "int256[]",
                    "internalType": "int256[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envInt",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "value", "type": "int256", "internalType": "int256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "int256[]",
                    "internalType": "int256[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "bool",
                    "internalType": "bool",
                },
            ],
            "outputs": [
                {"name": "value", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [
                {"name": "value", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [
                {"name": "value", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "bytes[]",
                    "internalType": "bytes[]",
                },
            ],
            "outputs": [
                {"name": "value", "type": "bytes[]", "internalType": "bytes[]"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "string[]",
                    "internalType": "string[]",
                },
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "string[]",
                    "internalType": "string[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "bytes",
                    "internalType": "bytes",
                },
            ],
            "outputs": [
                {"name": "value", "type": "bytes", "internalType": "bytes"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {"name": "value", "type": "bytes32", "internalType": "bytes32"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "int256",
                    "internalType": "int256",
                },
            ],
            "outputs": [
                {"name": "value", "type": "int256", "internalType": "int256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "address[]",
                    "internalType": "address[]",
                },
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "address[]",
                    "internalType": "address[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "string",
                    "internalType": "string",
                },
            ],
            "outputs": [
                {"name": "value", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envOr",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
                {
                    "name": "defaultValue",
                    "type": "bool[]",
                    "internalType": "bool[]",
                },
            ],
            "outputs": [
                {"name": "value", "type": "bool[]", "internalType": "bool[]"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envString",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "string[]",
                    "internalType": "string[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envString",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "value", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envUint",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "value", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "envUint",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "delim", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {
                    "name": "value",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "etch",
            "inputs": [
                {
                    "name": "target",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "newRuntimeBytecode",
                    "type": "bytes",
                    "internalType": "bytes",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "eth_getLogs",
            "inputs": [
                {
                    "name": "fromBlock",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "toBlock",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "target",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "topics",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
            ],
            "outputs": [
                {
                    "name": "logs",
                    "type": "tuple[]",
                    "internalType": "struct VmSafe.EthGetLogs[]",
                    "components": [
                        {
                            "name": "emitter",
                            "type": "address",
                            "internalType": "address",
                        },
                        {
                            "name": "topics",
                            "type": "bytes32[]",
                            "internalType": "bytes32[]",
                        },
                        {
                            "name": "data",
                            "type": "bytes",
                            "internalType": "bytes",
                        },
                        {
                            "name": "blockHash",
                            "type": "bytes32",
                            "internalType": "bytes32",
                        },
                        {
                            "name": "blockNumber",
                            "type": "uint64",
                            "internalType": "uint64",
                        },
                        {
                            "name": "transactionHash",
                            "type": "bytes32",
                            "internalType": "bytes32",
                        },
                        {
                            "name": "transactionIndex",
                            "type": "uint64",
                            "internalType": "uint64",
                        },
                        {
                            "name": "logIndex",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "removed",
                            "type": "bool",
                            "internalType": "bool",
                        },
                    ],
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "exists",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "result", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectCall",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "msgValue",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "gas", "type": "uint64", "internalType": "uint64"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectCall",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "msgValue",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "gas", "type": "uint64", "internalType": "uint64"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {"name": "count", "type": "uint64", "internalType": "uint64"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectCall",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "msgValue",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {"name": "count", "type": "uint64", "internalType": "uint64"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectCall",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectCall",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {"name": "count", "type": "uint64", "internalType": "uint64"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectCall",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "msgValue",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectCallMinGas",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "msgValue",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "minGas", "type": "uint64", "internalType": "uint64"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectCallMinGas",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "msgValue",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "minGas", "type": "uint64", "internalType": "uint64"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {"name": "count", "type": "uint64", "internalType": "uint64"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectEmit",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectEmit",
            "inputs": [
                {"name": "checkTopic1", "type": "bool", "internalType": "bool"},
                {"name": "checkTopic2", "type": "bool", "internalType": "bool"},
                {"name": "checkTopic3", "type": "bool", "internalType": "bool"},
                {"name": "checkData", "type": "bool", "internalType": "bool"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectEmit",
            "inputs": [
                {"name": "checkTopic1", "type": "bool", "internalType": "bool"},
                {"name": "checkTopic2", "type": "bool", "internalType": "bool"},
                {"name": "checkTopic3", "type": "bool", "internalType": "bool"},
                {"name": "checkData", "type": "bool", "internalType": "bool"},
                {
                    "name": "emitter",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectEmit",
            "inputs": [
                {
                    "name": "emitter",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectRevert",
            "inputs": [
                {
                    "name": "revertData",
                    "type": "bytes4",
                    "internalType": "bytes4",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectRevert",
            "inputs": [
                {"name": "revertData", "type": "bytes", "internalType": "bytes"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectRevert",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectSafeMemory",
            "inputs": [
                {"name": "min", "type": "uint64", "internalType": "uint64"},
                {"name": "max", "type": "uint64", "internalType": "uint64"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "expectSafeMemoryCall",
            "inputs": [
                {"name": "min", "type": "uint64", "internalType": "uint64"},
                {"name": "max", "type": "uint64", "internalType": "uint64"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "fee",
            "inputs": [
                {
                    "name": "newBasefee",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "ffi",
            "inputs": [
                {
                    "name": "commandInput",
                    "type": "string[]",
                    "internalType": "string[]",
                }
            ],
            "outputs": [
                {"name": "result", "type": "bytes", "internalType": "bytes"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "fsMetadata",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {
                    "name": "metadata",
                    "type": "tuple",
                    "internalType": "struct VmSafe.FsMetadata",
                    "components": [
                        {
                            "name": "isDir",
                            "type": "bool",
                            "internalType": "bool",
                        },
                        {
                            "name": "isSymlink",
                            "type": "bool",
                            "internalType": "bool",
                        },
                        {
                            "name": "length",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "readOnly",
                            "type": "bool",
                            "internalType": "bool",
                        },
                        {
                            "name": "modified",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "accessed",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "created",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getBlockNumber",
            "inputs": [],
            "outputs": [
                {"name": "height", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getBlockTimestamp",
            "inputs": [],
            "outputs": [
                {
                    "name": "timestamp",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getCode",
            "inputs": [
                {
                    "name": "artifactPath",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {
                    "name": "creationBytecode",
                    "type": "bytes",
                    "internalType": "bytes",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getDeployedCode",
            "inputs": [
                {
                    "name": "artifactPath",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {
                    "name": "runtimeBytecode",
                    "type": "bytes",
                    "internalType": "bytes",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getLabel",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [
                {
                    "name": "currentLabel",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getMappingKeyAndParentOf",
            "inputs": [
                {
                    "name": "target",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "elementSlot",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {"name": "found", "type": "bool", "internalType": "bool"},
                {"name": "key", "type": "bytes32", "internalType": "bytes32"},
                {
                    "name": "parent",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "getMappingLength",
            "inputs": [
                {
                    "name": "target",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "mappingSlot",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {"name": "length", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "getMappingSlotAt",
            "inputs": [
                {
                    "name": "target",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "mappingSlot",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
                {"name": "idx", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [
                {"name": "value", "type": "bytes32", "internalType": "bytes32"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "getNonce",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [
                {"name": "nonce", "type": "uint64", "internalType": "uint64"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "getNonce",
            "inputs": [
                {
                    "name": "wallet",
                    "type": "tuple",
                    "internalType": "struct VmSafe.Wallet",
                    "components": [
                        {
                            "name": "addr",
                            "type": "address",
                            "internalType": "address",
                        },
                        {
                            "name": "publicKeyX",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "publicKeyY",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "privateKey",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                }
            ],
            "outputs": [
                {"name": "nonce", "type": "uint64", "internalType": "uint64"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "getRecordedLogs",
            "inputs": [],
            "outputs": [
                {
                    "name": "logs",
                    "type": "tuple[]",
                    "internalType": "struct VmSafe.Log[]",
                    "components": [
                        {
                            "name": "topics",
                            "type": "bytes32[]",
                            "internalType": "bytes32[]",
                        },
                        {
                            "name": "data",
                            "type": "bytes",
                            "internalType": "bytes",
                        },
                        {
                            "name": "emitter",
                            "type": "address",
                            "internalType": "address",
                        },
                    ],
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "isDir",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "result", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "isFile",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "result", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "isPersistent",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [
                {"name": "persistent", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "keyExists",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [{"name": "", "type": "bool", "internalType": "bool"}],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "keyExistsJson",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [{"name": "", "type": "bool", "internalType": "bool"}],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "keyExistsToml",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [{"name": "", "type": "bool", "internalType": "bool"}],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "label",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "newLabel",
                    "type": "string",
                    "internalType": "string",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "load",
            "inputs": [
                {
                    "name": "target",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "slot", "type": "bytes32", "internalType": "bytes32"},
            ],
            "outputs": [
                {"name": "data", "type": "bytes32", "internalType": "bytes32"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "loadAllocs",
            "inputs": [
                {
                    "name": "pathToAllocsJson",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "makePersistent",
            "inputs": [
                {
                    "name": "accounts",
                    "type": "address[]",
                    "internalType": "address[]",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "makePersistent",
            "inputs": [
                {
                    "name": "account0",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "account1",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "makePersistent",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "makePersistent",
            "inputs": [
                {
                    "name": "account0",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "account1",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "account2",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "mockCall",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "msgValue",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "returnData",
                    "type": "bytes",
                    "internalType": "bytes",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "mockCall",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "returnData",
                    "type": "bytes",
                    "internalType": "bytes",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "mockCallRevert",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "msgValue",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "revertData",
                    "type": "bytes",
                    "internalType": "bytes",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "mockCallRevert",
            "inputs": [
                {
                    "name": "callee",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "data", "type": "bytes", "internalType": "bytes"},
                {
                    "name": "revertData",
                    "type": "bytes",
                    "internalType": "bytes",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "parseAddress",
            "inputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {
                    "name": "parsedValue",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseBool",
            "inputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {"name": "parsedValue", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseBytes",
            "inputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {
                    "name": "parsedValue",
                    "type": "bytes",
                    "internalType": "bytes",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseBytes32",
            "inputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {
                    "name": "parsedValue",
                    "type": "bytes32",
                    "internalType": "bytes32",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseInt",
            "inputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {
                    "name": "parsedValue",
                    "type": "int256",
                    "internalType": "int256",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJson",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {
                    "name": "abiEncodedData",
                    "type": "bytes",
                    "internalType": "bytes",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJson",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {
                    "name": "abiEncodedData",
                    "type": "bytes",
                    "internalType": "bytes",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonAddress",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonAddressArray",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "address[]", "internalType": "address[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonBool",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [{"name": "", "type": "bool", "internalType": "bool"}],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonBoolArray",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "bool[]", "internalType": "bool[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonBytes",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [{"name": "", "type": "bytes", "internalType": "bytes"}],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonBytes32",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "bytes32", "internalType": "bytes32"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonBytes32Array",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "bytes32[]", "internalType": "bytes32[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonBytesArray",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "bytes[]", "internalType": "bytes[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonInt",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "int256", "internalType": "int256"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonIntArray",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "int256[]", "internalType": "int256[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonKeys",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "keys", "type": "string[]", "internalType": "string[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonString",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonStringArray",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "string[]", "internalType": "string[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonUint",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseJsonUintArray",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "uint256[]", "internalType": "uint256[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseToml",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {
                    "name": "abiEncodedData",
                    "type": "bytes",
                    "internalType": "bytes",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseToml",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {
                    "name": "abiEncodedData",
                    "type": "bytes",
                    "internalType": "bytes",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlAddress",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "address", "internalType": "address"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlAddressArray",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "address[]", "internalType": "address[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlBool",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [{"name": "", "type": "bool", "internalType": "bool"}],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlBoolArray",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "bool[]", "internalType": "bool[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlBytes",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [{"name": "", "type": "bytes", "internalType": "bytes"}],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlBytes32",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "bytes32", "internalType": "bytes32"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlBytes32Array",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "bytes32[]", "internalType": "bytes32[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlBytesArray",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "bytes[]", "internalType": "bytes[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlInt",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "int256", "internalType": "int256"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlIntArray",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "int256[]", "internalType": "int256[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlKeys",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "keys", "type": "string[]", "internalType": "string[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlString",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlStringArray",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "string[]", "internalType": "string[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlUint",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "uint256", "internalType": "uint256"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseTomlUintArray",
            "inputs": [
                {"name": "toml", "type": "string", "internalType": "string"},
                {"name": "key", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "", "type": "uint256[]", "internalType": "uint256[]"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "parseUint",
            "inputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "outputs": [
                {
                    "name": "parsedValue",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "pauseGasMetering",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "prank",
            "inputs": [
                {
                    "name": "msgSender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "txOrigin",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "prank",
            "inputs": [
                {
                    "name": "msgSender",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "prevrandao",
            "inputs": [
                {
                    "name": "newPrevrandao",
                    "type": "bytes32",
                    "internalType": "bytes32",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "projectRoot",
            "inputs": [],
            "outputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "readCallers",
            "inputs": [],
            "outputs": [
                {
                    "name": "callerMode",
                    "type": "uint8",
                    "internalType": "enum VmSafe.CallerMode",
                },
                {
                    "name": "msgSender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "txOrigin",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "readDir",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"},
                {
                    "name": "maxDepth",
                    "type": "uint64",
                    "internalType": "uint64",
                },
            ],
            "outputs": [
                {
                    "name": "entries",
                    "type": "tuple[]",
                    "internalType": "struct VmSafe.DirEntry[]",
                    "components": [
                        {
                            "name": "errorMessage",
                            "type": "string",
                            "internalType": "string",
                        },
                        {
                            "name": "path",
                            "type": "string",
                            "internalType": "string",
                        },
                        {
                            "name": "depth",
                            "type": "uint64",
                            "internalType": "uint64",
                        },
                        {
                            "name": "isDir",
                            "type": "bool",
                            "internalType": "bool",
                        },
                        {
                            "name": "isSymlink",
                            "type": "bool",
                            "internalType": "bool",
                        },
                    ],
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "readDir",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"},
                {
                    "name": "maxDepth",
                    "type": "uint64",
                    "internalType": "uint64",
                },
                {"name": "followLinks", "type": "bool", "internalType": "bool"},
            ],
            "outputs": [
                {
                    "name": "entries",
                    "type": "tuple[]",
                    "internalType": "struct VmSafe.DirEntry[]",
                    "components": [
                        {
                            "name": "errorMessage",
                            "type": "string",
                            "internalType": "string",
                        },
                        {
                            "name": "path",
                            "type": "string",
                            "internalType": "string",
                        },
                        {
                            "name": "depth",
                            "type": "uint64",
                            "internalType": "uint64",
                        },
                        {
                            "name": "isDir",
                            "type": "bool",
                            "internalType": "bool",
                        },
                        {
                            "name": "isSymlink",
                            "type": "bool",
                            "internalType": "bool",
                        },
                    ],
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "readDir",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {
                    "name": "entries",
                    "type": "tuple[]",
                    "internalType": "struct VmSafe.DirEntry[]",
                    "components": [
                        {
                            "name": "errorMessage",
                            "type": "string",
                            "internalType": "string",
                        },
                        {
                            "name": "path",
                            "type": "string",
                            "internalType": "string",
                        },
                        {
                            "name": "depth",
                            "type": "uint64",
                            "internalType": "uint64",
                        },
                        {
                            "name": "isDir",
                            "type": "bool",
                            "internalType": "bool",
                        },
                        {
                            "name": "isSymlink",
                            "type": "bool",
                            "internalType": "bool",
                        },
                    ],
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "readFile",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "data", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "readFileBinary",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "data", "type": "bytes", "internalType": "bytes"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "readLine",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "line", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "readLink",
            "inputs": [
                {"name": "linkPath", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {
                    "name": "targetPath",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "record",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "recordLogs",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "rememberKey",
            "inputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [
                {
                    "name": "keyAddr",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "removeDir",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"},
                {"name": "recursive", "type": "bool", "internalType": "bool"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "removeFile",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "replace",
            "inputs": [
                {"name": "input", "type": "string", "internalType": "string"},
                {"name": "from", "type": "string", "internalType": "string"},
                {"name": "to", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "output", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "resetNonce",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "resumeGasMetering",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "revertTo",
            "inputs": [
                {
                    "name": "snapshotId",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [
                {"name": "success", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "revertToAndDelete",
            "inputs": [
                {
                    "name": "snapshotId",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [
                {"name": "success", "type": "bool", "internalType": "bool"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "revokePersistent",
            "inputs": [
                {
                    "name": "accounts",
                    "type": "address[]",
                    "internalType": "address[]",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "revokePersistent",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "roll",
            "inputs": [
                {
                    "name": "newHeight",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "rollFork",
            "inputs": [
                {"name": "txHash", "type": "bytes32", "internalType": "bytes32"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "rollFork",
            "inputs": [
                {
                    "name": "forkId",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "blockNumber",
                    "type": "uint256",
                    "internalType": "uint256",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "rollFork",
            "inputs": [
                {
                    "name": "blockNumber",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "rollFork",
            "inputs": [
                {
                    "name": "forkId",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "txHash",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "rpc",
            "inputs": [
                {"name": "method", "type": "string", "internalType": "string"},
                {"name": "params", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "data", "type": "bytes", "internalType": "bytes"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "rpcUrl",
            "inputs": [
                {"name": "rpcAlias", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "rpcUrlStructs",
            "inputs": [],
            "outputs": [
                {
                    "name": "urls",
                    "type": "tuple[]",
                    "internalType": "struct VmSafe.Rpc[]",
                    "components": [
                        {
                            "name": "key",
                            "type": "string",
                            "internalType": "string",
                        },
                        {
                            "name": "url",
                            "type": "string",
                            "internalType": "string",
                        },
                    ],
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "rpcUrls",
            "inputs": [],
            "outputs": [
                {
                    "name": "urls",
                    "type": "string[2][]",
                    "internalType": "string[2][]",
                }
            ],
            "stateMutability": "view",
        },
        {
            "type": "function",
            "name": "selectFork",
            "inputs": [
                {"name": "forkId", "type": "uint256", "internalType": "uint256"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeAddress",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "values",
                    "type": "address[]",
                    "internalType": "address[]",
                },
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeAddress",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "value", "type": "address", "internalType": "address"},
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeBool",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "values", "type": "bool[]", "internalType": "bool[]"},
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeBool",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "value", "type": "bool", "internalType": "bool"},
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeBytes",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "values",
                    "type": "bytes[]",
                    "internalType": "bytes[]",
                },
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeBytes",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "value", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeBytes32",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "values",
                    "type": "bytes32[]",
                    "internalType": "bytes32[]",
                },
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeBytes32",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "value", "type": "bytes32", "internalType": "bytes32"},
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeInt",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "value", "type": "int256", "internalType": "int256"},
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeInt",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "values",
                    "type": "int256[]",
                    "internalType": "int256[]",
                },
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeJson",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "value", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeString",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "values",
                    "type": "string[]",
                    "internalType": "string[]",
                },
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeString",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "value", "type": "string", "internalType": "string"},
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeUint",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "value", "type": "uint256", "internalType": "uint256"},
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "serializeUint",
            "inputs": [
                {
                    "name": "objectKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "values",
                    "type": "uint256[]",
                    "internalType": "uint256[]",
                },
            ],
            "outputs": [
                {"name": "json", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "setEnv",
            "inputs": [
                {"name": "name", "type": "string", "internalType": "string"},
                {"name": "value", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "setNonce",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "newNonce",
                    "type": "uint64",
                    "internalType": "uint64",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "setNonceUnsafe",
            "inputs": [
                {
                    "name": "account",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "newNonce",
                    "type": "uint64",
                    "internalType": "uint64",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "sign",
            "inputs": [
                {
                    "name": "wallet",
                    "type": "tuple",
                    "internalType": "struct VmSafe.Wallet",
                    "components": [
                        {
                            "name": "addr",
                            "type": "address",
                            "internalType": "address",
                        },
                        {
                            "name": "publicKeyX",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "publicKeyY",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "privateKey",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                    ],
                },
                {
                    "name": "digest",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {"name": "v", "type": "uint8", "internalType": "uint8"},
                {"name": "r", "type": "bytes32", "internalType": "bytes32"},
                {"name": "s", "type": "bytes32", "internalType": "bytes32"},
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "sign",
            "inputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "digest",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {"name": "v", "type": "uint8", "internalType": "uint8"},
                {"name": "r", "type": "bytes32", "internalType": "bytes32"},
                {"name": "s", "type": "bytes32", "internalType": "bytes32"},
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "signP256",
            "inputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "digest",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [
                {"name": "r", "type": "bytes32", "internalType": "bytes32"},
                {"name": "s", "type": "bytes32", "internalType": "bytes32"},
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "skip",
            "inputs": [
                {"name": "skipTest", "type": "bool", "internalType": "bool"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "sleep",
            "inputs": [
                {
                    "name": "duration",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "snapshot",
            "inputs": [],
            "outputs": [
                {
                    "name": "snapshotId",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "split",
            "inputs": [
                {"name": "input", "type": "string", "internalType": "string"},
                {
                    "name": "delimiter",
                    "type": "string",
                    "internalType": "string",
                },
            ],
            "outputs": [
                {
                    "name": "outputs",
                    "type": "string[]",
                    "internalType": "string[]",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "startBroadcast",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "startBroadcast",
            "inputs": [
                {"name": "signer", "type": "address", "internalType": "address"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "startBroadcast",
            "inputs": [
                {
                    "name": "privateKey",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "startMappingRecording",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "startPrank",
            "inputs": [
                {
                    "name": "msgSender",
                    "type": "address",
                    "internalType": "address",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "startPrank",
            "inputs": [
                {
                    "name": "msgSender",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "txOrigin",
                    "type": "address",
                    "internalType": "address",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "startStateDiffRecording",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "stopAndReturnStateDiff",
            "inputs": [],
            "outputs": [
                {
                    "name": "accountAccesses",
                    "type": "tuple[]",
                    "internalType": "struct VmSafe.AccountAccess[]",
                    "components": [
                        {
                            "name": "chainInfo",
                            "type": "tuple",
                            "internalType": "struct VmSafe.ChainInfo",
                            "components": [
                                {
                                    "name": "forkId",
                                    "type": "uint256",
                                    "internalType": "uint256",
                                },
                                {
                                    "name": "chainId",
                                    "type": "uint256",
                                    "internalType": "uint256",
                                },
                            ],
                        },
                        {
                            "name": "kind",
                            "type": "uint8",
                            "internalType": "enum VmSafe.AccountAccessKind",
                        },
                        {
                            "name": "account",
                            "type": "address",
                            "internalType": "address",
                        },
                        {
                            "name": "accessor",
                            "type": "address",
                            "internalType": "address",
                        },
                        {
                            "name": "initialized",
                            "type": "bool",
                            "internalType": "bool",
                        },
                        {
                            "name": "oldBalance",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "newBalance",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "deployedCode",
                            "type": "bytes",
                            "internalType": "bytes",
                        },
                        {
                            "name": "value",
                            "type": "uint256",
                            "internalType": "uint256",
                        },
                        {
                            "name": "data",
                            "type": "bytes",
                            "internalType": "bytes",
                        },
                        {
                            "name": "reverted",
                            "type": "bool",
                            "internalType": "bool",
                        },
                        {
                            "name": "storageAccesses",
                            "type": "tuple[]",
                            "internalType": "struct VmSafe.StorageAccess[]",
                            "components": [
                                {
                                    "name": "account",
                                    "type": "address",
                                    "internalType": "address",
                                },
                                {
                                    "name": "slot",
                                    "type": "bytes32",
                                    "internalType": "bytes32",
                                },
                                {
                                    "name": "isWrite",
                                    "type": "bool",
                                    "internalType": "bool",
                                },
                                {
                                    "name": "previousValue",
                                    "type": "bytes32",
                                    "internalType": "bytes32",
                                },
                                {
                                    "name": "newValue",
                                    "type": "bytes32",
                                    "internalType": "bytes32",
                                },
                                {
                                    "name": "reverted",
                                    "type": "bool",
                                    "internalType": "bool",
                                },
                            ],
                        },
                        {
                            "name": "depth",
                            "type": "uint64",
                            "internalType": "uint64",
                        },
                    ],
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "stopBroadcast",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "stopExpectSafeMemory",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "stopMappingRecording",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "stopPrank",
            "inputs": [],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "store",
            "inputs": [
                {
                    "name": "target",
                    "type": "address",
                    "internalType": "address",
                },
                {"name": "slot", "type": "bytes32", "internalType": "bytes32"},
                {"name": "value", "type": "bytes32", "internalType": "bytes32"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "toBase64",
            "inputs": [
                {"name": "data", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toBase64",
            "inputs": [
                {"name": "data", "type": "bytes", "internalType": "bytes"}
            ],
            "outputs": [
                {"name": "", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toBase64URL",
            "inputs": [
                {"name": "data", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toBase64URL",
            "inputs": [
                {"name": "data", "type": "bytes", "internalType": "bytes"}
            ],
            "outputs": [
                {"name": "", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toLowercase",
            "inputs": [
                {"name": "input", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "output", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toString",
            "inputs": [
                {"name": "value", "type": "address", "internalType": "address"}
            ],
            "outputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toString",
            "inputs": [
                {"name": "value", "type": "uint256", "internalType": "uint256"}
            ],
            "outputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toString",
            "inputs": [
                {"name": "value", "type": "bytes", "internalType": "bytes"}
            ],
            "outputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toString",
            "inputs": [
                {"name": "value", "type": "bool", "internalType": "bool"}
            ],
            "outputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toString",
            "inputs": [
                {"name": "value", "type": "int256", "internalType": "int256"}
            ],
            "outputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toString",
            "inputs": [
                {"name": "value", "type": "bytes32", "internalType": "bytes32"}
            ],
            "outputs": [
                {
                    "name": "stringifiedValue",
                    "type": "string",
                    "internalType": "string",
                }
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "toUppercase",
            "inputs": [
                {"name": "input", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "output", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "transact",
            "inputs": [
                {
                    "name": "forkId",
                    "type": "uint256",
                    "internalType": "uint256",
                },
                {
                    "name": "txHash",
                    "type": "bytes32",
                    "internalType": "bytes32",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "transact",
            "inputs": [
                {"name": "txHash", "type": "bytes32", "internalType": "bytes32"}
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "trim",
            "inputs": [
                {"name": "input", "type": "string", "internalType": "string"}
            ],
            "outputs": [
                {"name": "output", "type": "string", "internalType": "string"}
            ],
            "stateMutability": "pure",
        },
        {
            "type": "function",
            "name": "tryFfi",
            "inputs": [
                {
                    "name": "commandInput",
                    "type": "string[]",
                    "internalType": "string[]",
                }
            ],
            "outputs": [
                {
                    "name": "result",
                    "type": "tuple",
                    "internalType": "struct VmSafe.FfiResult",
                    "components": [
                        {
                            "name": "exitCode",
                            "type": "int32",
                            "internalType": "int32",
                        },
                        {
                            "name": "stdout",
                            "type": "bytes",
                            "internalType": "bytes",
                        },
                        {
                            "name": "stderr",
                            "type": "bytes",
                            "internalType": "bytes",
                        },
                    ],
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "txGasPrice",
            "inputs": [
                {
                    "name": "newGasPrice",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "unixTime",
            "inputs": [],
            "outputs": [
                {
                    "name": "milliseconds",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "warp",
            "inputs": [
                {
                    "name": "newTimestamp",
                    "type": "uint256",
                    "internalType": "uint256",
                }
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "writeFile",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"},
                {"name": "data", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "writeFileBinary",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"},
                {"name": "data", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "writeJson",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "path", "type": "string", "internalType": "string"},
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "writeJson",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "path", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "writeLine",
            "inputs": [
                {"name": "path", "type": "string", "internalType": "string"},
                {"name": "data", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "writeToml",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "path", "type": "string", "internalType": "string"},
                {
                    "name": "valueKey",
                    "type": "string",
                    "internalType": "string",
                },
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "function",
            "name": "writeToml",
            "inputs": [
                {"name": "json", "type": "string", "internalType": "string"},
                {"name": "path", "type": "string", "internalType": "string"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
    ],
)
# pylint: disable=line-too-long
vm_bytecode = HexStr("0x")


class VmContract(Contract):
    """A web3.py Contract class for the Vm contract."""

    abi: ABI = vm_abi
    bytecode: bytes | None = try_bytecode_hexbytes(vm_bytecode, "vm")

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        try:
            # Initialize parent Contract class
            super().__init__(address=address)
            self.functions = VmContractFunctions(vm_abi, self.w3, address)  # type: ignore

        except FallbackNotFound:
            print("Fallback function not found. Continuing...")

    functions: VmContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.rawTransaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Deploys and instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = VmContractFunctions(vm_abi, w3, None)

        return contract
